<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "calendar.php";

function version() {
  return "2.33-rc4";
}

function xml_to_html($xml_code) {
  $xml_code = ereg_replace("<", "&lt;", $xml_code);
  $xml_code = ereg_replace(">", "&gt;", $xml_code);
  $xml_code = ereg_replace('\"', "&quot;", $xml_code);
  $xml_code = ereg_replace("\n", "<br/>\n", $xml_code);
  return $xml_code;
}

function get_path_to_folder($database, $folder_id) {
  $stack_size = 0;

  $folder_data = pg_fetch_row(pg_query($database, "
      select parent_folder, folder.caption
        from folder
       where folder.identifier = '$folder_id'"));
  $folder_id = $folder_data[0];

  if ($folder_id == "")
    return;

  do {
    $folder_data = pg_fetch_row(pg_query($database, "
      select parent_folder, folder.caption
        from folder
       where folder.identifier = '$folder_id'"));
    $folder_data[1] = strip_tags($folder_data[1]);
    $folder_data[1] = makeZanza($folder_data[1], "No caption");
    $stack[$stack_size] = "<a href=folder.php?folder=$folder_id>$folder_data[1]</a>";
    $folder_id = $folder_data[0];
    $stack_size++;
  } while ($folder_id);

  $path = "";
  for ($i = $stack_size - 1; $i >= 0; $i--) {
    $path = $path . " : $stack[$i]";
  }

  return $path;
}

function get_path_to_album($database, $folder_id) {
  $stack_size = 0;

  $folder_data = pg_fetch_row(pg_query($database, "
      select parent_album, album.caption
        from album
       where album.identifier = '$folder_id'"));
  $folder_id = $folder_data[0];

  if ($folder_id == "")
    return;

  do {
    $folder_data = pg_fetch_row(pg_query($database, "
      select parent_album, album.caption
        from album
       where album.identifier = '$folder_id'"));
    $folder_data[1] = strip_tags($folder_data[1]);
    $folder_data[1] = makeZanza($folder_data[1], "No caption");
    $stack[$stack_size] = "<a href=album.php?album=$folder_id>$folder_data[1]</a>";
    $folder_id = $folder_data[0];
    $stack_size++;
  } while ($folder_id);

  $path = "";
  for ($i = $stack_size - 1; $i >= 0; $i--) {
    $path = $path . " : $stack[$i]";
  }

  return $path;
}

function get_photo_title($caption, $title) {
  $new_title = $title ? $title : $caption;
  if (!$new_title)
    $new_title = "No Title";
  return $new_title;
}

function display_data_decoding_radio() {
  print "<table cellpadding=\"0\" cellspacing=\"3\">\n";
  print "<tr>";
  print "<td>&nbsp;</td>";
  print "<td align=\"center\">Skip</td>";
  print "<td align=\"center\">1st</td>";
  print "<td align=\"center\">2nd</td>";
  print "<td align=\"center\">3rd</td>";
  print "</tr>";
  print "<tr>";
  print "<td>EXIF</td>";
  print "<td><input type=\"radio\" name=\"decode_exif\" onClick=\"disabler1();\" value=\"0\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_exif\" onClick=\"disabler1();\" value=\"1\" checked/></td>";
  print "<td><input type=\"radio\" name=\"decode_exif\" onClick=\"disabler1();\" value=\"2\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_exif\" onClick=\"disabler1();\" value=\"3\"/></td>";
  print "</tr>";
  print "<tr>";
  print "<td>IPTC</td>";
  print "<td><input type=\"radio\" name=\"decode_iptc\" onClick=\"disabler2();\" value=\"0\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_iptc\" onClick=\"disabler2();\" value=\"1\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_iptc\" onClick=\"disabler2();\" value=\"2\" checked/></td>";
  print "<td><input type=\"radio\" name=\"decode_iptc\" onClick=\"disabler2();\" value=\"3\"/></td>";
  print "</tr>";
  print "<tr>";
  print "<td>XMP</td>";
  print "<td><input type=\"radio\" name=\"decode_rdf\" onClick=\"disabler3();\" value=\"0\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_rdf\" onClick=\"disabler3();\" value=\"1\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_rdf\" onClick=\"disabler3();\" value=\"2\"/></td>";
  print "<td><input type=\"radio\" name=\"decode_rdf\" onClick=\"disabler3();\" value=\"3\" checked/></td>";
  print "</tr>";
  print "</table>\n";
}

function display_storage_location_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  switch ($current_value) {
  case "album":
    print "<option value=\"TRAY\">TRAY</option>";
    print "<option value=\"ALBUM\" selected=\"selected\">ALBUM</option>";
    print "<option value=\"CDR\">CDR</option>";
    print "<option value=\"null\"></option>";
    break;
  case "cd":
    print "<option value=\"TRAY\">TRAY</option>";
    print "<option value=\"ALBUM\">ALBUM</option>";
    print "<option value=\"CDR\" selected=\"selected\">CDR</option>";
    print "<option value=\"null\"></option>";
    break;
  case "tray":
    print "<option value=\"TRAY\" selected=\"selected\">TRAY</option>";
    print "<option value=\"ALBUM\">ALBUM</option>";
    print "<option value=\"CDR\">CDR</option>";
    print "<option value=\"null\"></option>";
    break;
  default:
    print "<option value=\"TRAY\">TRAY</option>";
    print "<option value=\"ALBUM\">ALBUM</option>";
    print "<option value=\"CDR\">CDR</option>";
    print "<option value=\"null\" selected=\"selected\"></option>";
  }
  print "</select>";
}

function display_folder_view_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  if ($current_value == "list") {
    print "<option value=\"slide\">Slide View</option>";
    print "<option value=\"list\" selected=\"selected\">List View</option>";
  }
  else {
    print "<option value=\"slide\" selected=\"selected\">Slide View</option>";
    print "<option value=\"list\">List View</option>";
  }
  print "</select>";
}

function display_num_of_rows_combo($identifier, $current_value, $max_row) {
  print "<select name=\"$identifier\">";
  for ($i=1; $i < ($max_row + 1); $i++) {
    if ($i == $current_value)
      print "<option value=\"$i\" selected=\"selected\">$i</option>";
    else
      print "<option value=\"$i\">$i</option>";
  }
  if ($current_value == 3000)
    print "<option value=\"3000\" selected=\"selected\">Display all</option>";
  else
    print "<option value=\"3000\">Display all</option>";
  print "</select>";
}

function display_num_of_columns_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  for ($i=1; $i < 21; $i++) {
    if ($i == $current_value)
      print "<option value=\"$i\" selected=\"selected\">$i</option>";
    else
      print "<option value=\"$i\">$i</option>";
  }
  print "</select>";
}

function display_image_size($identifier, $current_value) {
  $values = array(100, 125, 150, 175, 200, 225, 250, 275, 300, 350, 400, 450, 500, 550, 600, 650, 700, 750, 800);
  print "<select name=\"$identifier\">";

  for ($i=0; $i < 19; $i++) {
    if ($values[$i] == $current_value)
      print "<option value=\"$values[$i]\" selected=\"selected\">$values[$i]</option>";
    else
      print "<option value=\"$values[$i]\">$values[$i]</option>";
  }
  print "</select>";
}

function display_print_format_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  if (strncmp($current_value, "ps", 2) == 0) {
    print "<option value=\"ps\" selected=\"selected\">PS - Post Script</option>";
    print "<option value=\"pdf\">PDF - Portable Document Format</option>";
  }
  else {
    print "<option value=\"pdf\" selected=\"selected\">PDF - Portable Document Format</option>";
    print "<option value=\"ps\">PS - Post Script</option>";
  }
  print "</select>";
}

function display_type_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  switch ($current_value) {
  case 'u':
    print "<option value=\"u\" selected=\"selected\">User only</option>";
    print "<option value=\"c\">Client only</option>";
    print "<option value=\"b\">User and Client</option>";
    break;
  case 'c':
    print "<option value=\"u\">User only</option>";
    print "<option value=\"c\" selected=\"selected\">Client only</option>";
    print "<option value=\"b\">User and Client</option>";
    break;
  case 'b':
    print "<option value=\"u\">User only</option>";
    print "<option value=\"c\">Client only</option>";
    print "<option value=\"b\" selected=\"selected\">User and Client</option>";
    break;
  default:
    print "<option value=\"u\">User only</option>";
    print "<option value=\"c\">Client only</option>";
    print "<option value=\"b\">User and Client</option>";
    break;
  }
  print "</select>";
}

function display_popup_delay_combo($identifier, $popup_delay, $popup_enable) {
  print "<select name=\"$identifier\">";
  if ($popup_enable == 'f') {
    print "<option value=\"f\" selected=\"selected\">Disabled</option>";
  }
  else {
    print "<option value=\"f\">Disabled</option>";
  }

  for ($i=100; $i <= 2000; $i+=100) {
    if ($i == $popup_delay)
      print "<option value=\"$i\" selected=\"selected\">$i msec</option>";
    else
      print "<option value=\"$i\">$i msec</option>";
  }
  print "</select>";
}

function display_first_day_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  if ($current_value == 1) {
    print "<option value=\"1\" selected=\"selected\">Monday</option>";
    print "<option value=\"0\">Sunday</option>";
  }
  else {
    print "<option value=\"0\" selected=\"selected\">Sunday</option>";
    print "<option value=\"1\">Monday</option>";
  }

  print "</select>";
}

function display_search_engine_type_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  switch ($current_value) {
  default:
  case 1:
    print "<option value=\"1\" selected=\"selected\">General Text</option>";
    print "<option value=\"2\">Advanced Text</option>";
    print "<option value=\"3\">Image Layout</option>";
    print "<option value=\"4\">Image Color</option>";
    break;
  case 2:
    print "<option value=\"1\">General Text</option>";
    print "<option value=\"2\" selected=\"selected\">Advanced Text</option>";
    print "<option value=\"3\">Image Layout</option>";
    print "<option value=\"4\">Image Color</option>";
    break;
  case 3:
    print "<option value=\"1\">General Text</option>";
    print "<option value=\"2\">Advanced Text</option>";
    print "<option value=\"3\" selected=\"selected\">Image Layout</option>";
    print "<option value=\"4\">Image Color</option>";
    break;
  case 4:
    print "<option value=\"1\">General Text</option>";
    print "<option value=\"2\">Advanced Text</option>";
    print "<option value=\"3\">Image Layout</option>";
    print "<option value=\"4\" selected=\"selected\">Image Color</option>";
  }
  print "</select>";
}

function display_colorspace_combo($identifier, $current_value) {
  print "<select name=\"$identifier\">";
  switch($current_value) {
  case "-1":
    print "<option value=\"\" selected=\"selected\"></option>";
    print "<option value=\"1\">sRGB</option>";
    print "<option value=\"2\">AdobeRGB</option>";
    print "<option value=\"99\">Embedded</option>";
    break;
  case "2":
    print "<option value=\"1\">sRGB</option>";
    print "<option value=\"2\" selected=\"selected\">AdobeRGB</option>";
    print "<option value=\"99\">Embedded</option>";
    break;
  case "99":
    print "<option value=\"1\">sRGB</option>";
    print "<option value=\"2\">AdobeRGB</option>";
    print "<option value=\"99\" selected=\"selected\">Embedded</option>";
    break;
  case "1":
  default:
    print "<option value=\"1\" selected=\"selected\">sRGB</option>";
    print "<option value=\"2\">AdobeRGB</option>";
    print "<option value=\"99\">Embedded</option>";
    break;
  }
  print "</select>";
}

function display_photo_index_status($offset, $limit, $num_of_items) {
  $first_index = $offset + 1;
  $last_index = $offset + $limit;

  if ($last_index > $num_of_items)
    $last_index = $num_of_items;

  if (!$limit ||($limit == $num_of_items)) {
    if ($first_index < $last_index)
      return "<b>$first_index</b>-<b>$last_index</b>";
    else
      return "<b>$num_of_items</b>";
  }
  else
    return "<b>$first_index</b>-<b>$last_index</b> of <b>$num_of_items</b>";
}

function display_frame_top($width, $height, $border, $bgcolor, $theme) {
  print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
  print "<tr>\n";
  print "<td height=\"$border\" align=\"right\"  valign=\"bottom\"><img src=\"$theme/frame.top.left.gif\" alt=\"\" /></td>\n";
  print "<td height=\"$border\" align=\"center\" valign=\"bottom\" width=\"$width\" background=\"$theme/frame.top.edge.gif\"></td>\n";
  print "<td height=\"$border\" align=\"left\"   valign=\"bottom\"><img src=\"$theme/frame.top.right.gif\" alt=\"\" /></td>\n";
  print "</tr>\n";
  print "<tr height=\"$height\">\n";
  print "<td align=\"right\"  valign=\"middle\" width=\"$border\" background=\"$theme/frame.left.edge.gif\"></td>\n";
  print "<td align=\"center\" valign=\"middle\" width=\"$width\"  bgcolor=\"$bgcolor\" nowrap>\n";
}

function display_frame_bottom($width, $height, $border, $theme) {
  print "</td>\n";
  print "<td align=\"left\"   valign=\"middle\" width=\"$border\" background=\"$theme/frame.right.edge.gif\"></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td height=\"$border\" align=\"right\"  valign=\"top\"><img src=\"$theme/frame.bottom.left.gif\" alt=\"\" /></td>\n";
  print "<td height=\"$border\" align=\"center\" valign=\"top\" width=\"$width\" background=\"$theme/frame.bottom.edge.gif\"></td>\n";
  print "<td height=\"$border\" align=\"left\"   valign=\"top\"><img src=\"$theme/frame.bottom.right.gif\" alt=\"\"/></td>\n";
  print "</tr>\n";
  print "</table>\n";
}

function display_yes_no_text($value) {
  if ($value == 't')
    print "Yes";
  else
    print "No";
}


function display_yes_no_combo($item_name, $value) {
  print "<select name=\"$item_name\">\n";
  if ($value == 't') {
    print "<option value=\"t\" selected=\"selected\">Yes</option>";
    print "<option value=\"f\">No</option>";
  }
  else {
    print "<option value=\"t\">Yes</option>";
    print "<option value=\"f\" selected=\"selected\">No</option>";
  }
  print "</select>\n";
}

function display_enable_disable_text($value) {
  if ($value == 't')
    print "Enabled";
  else
    print "Disabled";
}

function display_user_quota($value, $type) {
  if ($type == 1) {
    $value  = round($value/1048576, 2);
  }

  if ($value == 0)
    print "Unlimited";
  else {
    print "$value";
    if ($type == 1)
      print " Mb";
  }
}

function display_enable_disable_combo($item_name, $value) {
  print "<select name=\"$item_name\">\n";
  if ($value == 't') {
    print "<option value=\"t\" selected=\"selected\">Enable</option>";
    print "<option value=\"f\">Disable</option>";
  }
  else {
    print "<option value=\"t\">Enable</option>";
    print "<option value=\"f\" selected=\"selected\">Disable</option>";
  }
  print "</select>\n";
}

function orientation_to_name($database, $orientation) {

    $orients = pg_query($database, "select name from orientations where identifier = $orientation");
	if (pg_num_rows($orients)) {
		$orients = pg_fetch_row($orients);
		return $orients[0];
	}
	return "Unknown ($orientation)";
}

function orientation_to_xform($database, $orientation) {

    $orients = pg_query($database, "select im_transform from orientations where identifier = $orientation");
	if (pg_num_rows($orients)) {
		$orients = pg_fetch_row($orients);
		return $orients[0];
	}
	return "Unknown ($orientation)";

}

function orientation_id_from_string($database, $name) {
    $orients = pg_query($database, "select identifier from orientations where name = '$name'");
	if (pg_num_rows($orients)) {
		$orients = pg_fetch_row($orients);
		return $orients[0];
	}
	return "1";
}

function display_icc_profiles_combo($item_name, $value) {
  global $icc_profiles;
  $num_of_icc_profiles = count($icc_profiles) + 1;

  print "<select name=\"$item_name\">\n";
  print "<option value=\"null\">None</option>";
  for ($i = 1; $i < $num_of_icc_profiles; $i++) {
    print "<option value=\"$i\"";
    if ($i == $value)
    print " selected=\"selected\"";
    print ">".$icc_profiles[$i]['name']."</option>";
  }
  print "</select>\n";
}

function display_access_combo($item_name, $value, $kind) {
  print "<select name=\"$item_name\">\n";
  if ($kind == "null") {
    print "<option value=\"null\"";
    if (!$value)
      print " selected";
    print ">None</option>";
  }
  switch ($value) {
  case '1':
    print "<option value=\"1\" selected=\"selected\">Public</option>";
    print "<option value=\"2\">Protected</option>";
    print "<option value=\"3\">Private</option>";
    break;
  case '2':
    print "<option value=\"1\">Public</option>";
    print "<option value=\"2\" selected=\"selected\">Protected</option>";
    print "<option value=\"3\">Private</option>";
    break;
  case '3':
    print "<option value=\"1\">Public</option>";
    print "<option value=\"2\">Protected</option>";
    print "<option value=\"3\" selected=\"selected\">Private</option>";
    break;
  default:
    print "<option value=\"1\">Public</option>";
    print "<option value=\"2\">Protected</option>";
    print "<option value=\"3\">Private</option>";
    break;
  }
  print "</select>\n";
}

function display_hide_original_combo($item_name, $value) {
  print "<select name=\"$item_name\">\n";
  switch ($value) {
  case 'f':
    print "<option value=\"f\" selected=\"selected\">Accessible for authorized users</option>";
    print "<option value=\"t\">Accessible for owner only</option>";
    break;
  case 't':
  default:
    print "<option value=\"f\">Accessible for authorized users</option>";
    print "<option value=\"t\" selected=\"selected\">Accessible for owner only</option>";
    break;
  }
  print "</select>\n";
}

function display_download_counter_combo($item_name, $value) {
  print "<select name=\"$item_name\">\n";
  for ($pcs = 0; $pcs < 101; $pcs++) {
    print "<option value=\"$pcs\"";
    if ($pcs == $value) {
      print " selected ";
    }
    print ">$pcs</option>";
  }
  print "</select>\n";
}

function display_download_expiry_date_combo($item_name, $value) {
  print "<select name=\"$item_name\">\n";
  print "<option value=\"1\"";    if ($value == 1)    print " selected"; print">1 day</option>";
  print "<option value=\"2\"";    if ($value == 2)    print " selected"; print">2 days</option>";
  print "<option value=\"3\"";    if ($value == 3)    print " selected"; print">3 days</option>";
  print "<option value=\"4\"";    if ($value == 4)    print " selected"; print">4 days</option>";
  print "<option value=\"5\"";    if ($value == 5)    print " selected"; print">5 days</option>";
  print "<option value=\"6\"";    if ($value == 6)    print " selected"; print">6 days</option>";
  print "<option value=\"7\"";    if ($value == 7)    print " selected"; print">1 week</option>";
  print "<option value=\"14\"";   if ($value == 14)   print " selected"; print">2 weeks</option>";
  print "<option value=\"21\"";   if ($value == 21)   print " selected"; print">3 weeks</option>";
  print "<option value=\"30\"";   if ($value == 30)   print " selected"; print">1 month</option>";
  print "<option value=\"61\"";   if ($value == 61)   print " selected"; print">2 months</option>";
  print "<option value=\"91\"";   if ($value == 91)   print " selected"; print">3 months</option>";
  print "<option value=\"182\"";  if ($value == 182)  print " selected"; print">6 months</option>";
  print "<option value=\"365\"";  if ($value == 365)  print " selected"; print">1 year</option>";
  print "<option value=\"730\"";  if ($value == 730)  print " selected"; print">2 years</option>";
  print "<option value=\"1095\""; if ($value == 1095) print " selected"; print">3 years</option>";
  print "</select>\n";
}

function display_photo_navigator($display_type, $arguments, $user_id, $mode, $offset, $limit, $num_of_items) {
  global $theme;

  if ($limit < $num_of_items) {
    $last_photo_offset = $limit * floor($num_of_items/$limit);

    $previous_photo_offset = $offset - $limit;
    $next_photo_offset = $offset + $limit;

    if ($previous_photo_offset < 0)
      $previous_photo_offset = 0;

    if ($next_photo_offset > $last_photo_offset)
      $next_photo_offset = $last_photo_offset;

    if ($display_type == "folder") {
      $hyperlink = "folder.php?folder=$mode$arguments";
    }
    else if ($display_type == "search_general") {
      $hyperlink = "search.text.general.php?search_string=$mode$arguments";
    }
    else if ($display_type == "search_advanced") {
      $hyperlink = "search.text.advanced.php?search_string=$mode$arguments";
    }
    else if ($display_type == "album") {
      $hyperlink = "album.php?album=$mode$arguments";
    }

    print "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
    print "<tr>\n";
    print "<td align=\"center\" valign=\"top\">\n";
    print "<a class=\"nodecor\" href=\"$hyperlink&amp;offset=0\">";
    print "<img src=\"$theme/button.first.gif\" border=\"0\" alt=\"First\"/></a>";
    print "</td>\n";
    print "<td align=\"center\" valign=\"top\">\n";
    print "<a class=\"nodecor\" href=\"$hyperlink&amp;offset=$previous_photo_offset\">";
    print "<img src=\"$theme/button.previous.gif\" border=\"0\" alt=\"Previous\"/></a>\n";
    print "</td>\n";
    print "<td>&nbsp;</td>\n";
    print "<td valign=\"middle\">\n";
    print "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
    print "<tr>\n";
    $button_counter=0;
    for ($i=0; $i < ceil($num_of_items/$limit); $i++) {
      print "<td valign=\"middle\">\n";
      $aux=$i*$limit;
      print "<a class=\"nodecor\" href=\"$hyperlink&amp;offset=$aux\">";
      if (($aux) == $offset)
        print "<img src=\"$theme/button.option.a.gif\" border=\"0\" alt=\"*\"/></a>\n";
      else
        print "<img src=\"$theme/button.option.gif\" border=\"0\" alt=\"o\"/></a>\n";
      print "</td>\n";
      $button_counter++;
      if ($button_counter == 35) {
        $button_counter=0;
        print "</tr>\n<tr>\n";
      }
    }
    print "</tr>\n";
    print "</table>\n";
    print "</td>\n";
    print "<td>&nbsp;</td>\n";
    print "<td align=\"center\" valign=\"top\">\n";
    print "<a class=\"nodecor\" href=\"$hyperlink&amp;offset=$next_photo_offset\">";
    print "<img src=\"$theme/button.next.gif\" border=\"0\" alt=\"Next\"/></a>\n";
    print "</td>\n";
    print "<td align=\"center\" valign=\"top\">\n";
    print "<a class=\"nodecor\" href=\"$hyperlink&amp;offset=$last_photo_offset\">";
    print "<img src=\"$theme/button.last.gif\" border=\"0\" alt=\"Last\"/></a>\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
  }
}

function display_moveto_folder_entry($folder_data, $folder_id, $shift, $parameter) {
  $zanza = substr($folder_data[1], 0, 25);
  print "<option value=\"$folder_data[0]\"";
  if ($folder_data[0] == $folder_id) {
    print " $parameter";
  }
  print ">";
  for ($i = 0; $i < $shift; $i++) {
    print "&nbsp;&nbsp;";
  }
  $zanza = htmlspecialchars($zanza);

  print "$zanza</option>\n";
}

function display_moveto_recursive($folder_tmp, $folder_data, $folder_id, $shift, $parameter) {
  foreach($folder_tmp as $folder_sub_data) {
    if ($folder_sub_data[2] == $folder_data[0]) {
      display_moveto_folder_entry($folder_sub_data, $folder_id, $shift, $parameter);
      display_moveto_recursive($folder_tmp, $folder_sub_data, $folder_id, $shift + 1, $parameter);
    }
  }
}

function display_moveto_folder($folder_all, $folder_id, $type) {
  global $theme;
  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<input type=\"hidden\" name=\"source_folder\" value=\"$folder_id\"/>\n";
  switch ($type) {
  case "moveto":
    print "<input type=\"image\" src=\"$theme/button.move.to.gif\" value=\"Move to\"/>\n";
    print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
    print "<select name=\"destination_folder\">\n";
    break;
  case "goto":
    print "<input type=\"image\" src=\"$theme/button.goto.gif\" value=\"Move to\"/>\n";
    print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
    print "<select name=\"goto_folder\">\n";
    break;
  }
  print "<option value=\"\" selected=\"selected\">&nbsp;</option>\n";
  if ($folder_all != "") {
    $folder_tmp = array();
    for ($i=0; $i < pg_num_rows($folder_all); $i++) {
      $folder_tmp[$i] = pg_fetch_array($folder_all, $i);
    }

    foreach($folder_tmp as $folder_data) {
      if ($folder_data[2] == null) {
        display_moveto_folder_entry($folder_data, $folder_id, 0, "disabled=\"disabled\"");
        display_moveto_recursive($folder_tmp, $folder_data, $folder_id, 1, "disabled=\"disabled\"");
      }
    }
  }
  print "</select>\n";
  print "</td>\n</tr>\n</table>\n";
}

function display_linkto_album($album_all, $album_id) {
  global $theme;

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n<td align=\"left\" valign=\"middle\">\n";
  print "<input type=\"hidden\" name=\"source_album\" value=\"$album_id\"/>\n";
  print "<input type=\"image\" src=\"$theme/button.link.to.gif\" value=\"Link to\"/>\n";
  print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<select name=\"destination_album\">\n";
  print "<option value=\"\" selected=\"selected\">&nbsp;</option>\n";
  if ($album_all != "") {
    $album_tmp = array();
    for ($i=0; $i < pg_num_rows($album_all); $i++) {
      $album_tmp[$i] = pg_fetch_array($album_all, $i);
    }

    foreach($album_tmp as $album_data) {
      if ($album_data[2] == null) {
        display_moveto_folder_entry($album_data, $album_id, 0, "disabled=\"disabled\"");
        display_moveto_recursive($album_tmp, $album_data, $album_id, 1, "disabled=\"disabled\"");
      }
    }
  }
  print "</select>\n";
  print "</td>\n</tr>\n</table>\n";
}

function display_moveto_album($album_all, $album_id) {
  global $theme;

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n<td align=\"left\" valign=\"middle\">\n";
  print "<input type=\"image\" src=\"$theme/button.move.to.gif\" value=\"Link to\"/>\n";
  print "<input type=\"hidden\" name=\"move_source_album\" value=\"$album_id\"/>\n";
  print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<select name=\"destination_album\">\n";
  print "<option value=\"\" selected=\"selected\">&nbsp;</option>\n";
  if ($album_all != "") {
    $album_tmp = array();
    for ($i=0; $i < pg_num_rows($album_all); $i++) {
      $album_tmp[$i] = pg_fetch_array($album_all, $i);
    }

    foreach($album_tmp as $album_data) {
      if ($album_data[2] == null) {
        display_moveto_folder_entry($album_data, $album_id, 0, "disabled=\"disabled\"");
        display_moveto_recursive($album_tmp, $album_data, $album_id, 1, "disabled=\"disabled\"");
      }
    }
  }
  print "<option value=\"trash\">Trash</option>\n";
  print "</select>\n";
  print "</td>\n</tr>\n</table>\n";
}

function display_printto() {
  global $theme;

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n<td align=\"left\" valign=\"middle\">\n";
  print "<input type=\"image\" src=\"$theme/button.print.gif\" value=\"Print\"/>\n";
  print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<select name=\"print_type\">\n";
  print "<option value=\"\" selected=\"selected\">&nbsp;</option>\n";
  print "<option value=\"label\">Label</option>\n";
  print "<option value=\"brochure\">Brochure</option>\n";
  print "</select>\n";
  print "</td>\n</tr>\n</table>\n";
}

function display_export() {
  global $theme;

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n<td align=\"left\" valign=\"middle\">\n";
  print "<input type=\"image\" src=\"$theme/button.export.gif\" value=\"Export\"/>\n";
  print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<select name=\"export_type\">\n";
  print "<option value=\"\" selected=\"selected\">&nbsp</option>\n";
  print "<option value=\"photo\">Photos Only</option>\n";
  print "<option value=\"photo_xml\">Photos with XML</option>\n";
/*   print "<option value=\"photo_iptc\">Photos with IPTC</option>\n"; */
/*   print "<option value=\"photo_xml_iptc\">Photos with XML and IPTC</option>\n"; */
  print "</select>\n";
  print "</td>\n</tr>\n</table>\n";
}

function display_transform($photo_id) {
  global $theme;

  print "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n<td align=\"left\" valign=\"middle\">\n";
  print "<input type=\"image\" src=\"$theme/button.rotate.gif\" value=\"Rotate\"/>\n";
  print "</td>\n<td align=\"left\" valign=\"middle\" >\n";
  print "<select name=\"transform\">\n";
  print "<option value=\"\" selected=\"selected\">&nbsp;</option>\n";
  print "<option value=\"r90\">Rotate Right</option>\n";
  print "<option value=\"r180\">Rotate Upside-Down</option>\n";
  print "<option value=\"r270\">Rotate Left</option>\n";
  print "<option value=\"flip\">Flip Vertically</option>\n";
  print "<option value=\"flop\">Flop Horizontally</option>\n";
  print "</select>\n";
  print "</td>\n</tr>\n</table>\n";
}

/* returns one row of the tooltip table */
function tooltip_row($name, $value) {
  if ($value == "") {
	return "";
  }
  return '<tr><td align="right">' .$name. '</td><td align="left"><font class="popup">'.$value.'</font></td></tr>';
}

function display_photo_slides($display_type, $my_user_id, $my_user_type, $container_id, $photo_data, $num_of_items, $num_of_rows, $popup_enable, $popup_delay, $shop_enable, $framed, $order) {
  global $cell_size;
  global $color;
  global $theme;
  global $user_type;

  $option = "";

  if ($display_type == "album") {
    $option .= "&amp;album=$container_id";
  }
  if ($order) {
    $option .= "&amp;order_by=$order";
  }

  print "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" bgcolor=\"$bgcolor\">\n";
  $rows = 0;
  $checkboxes = 0;

  $round_down = floor($num_of_items/$num_of_rows);
  $round_up = ceil($num_of_items/$num_of_rows);
  $num_of_cells = $round_up == $round_down ? $num_of_items : ($round_down+1)*$num_of_rows;

  for ($cell_counter = 0; $cell_counter < $num_of_cells; $cell_counter++) {
    if ($rows == 0) {
      print "<tr>\n";
    }
    print "<td align=\"center\" valign=\"top\" width=\"$cell_size\" height=\"$cell_size\">\n";
    print "<table width=\"100%\">\n";
    print "<tr><td align=\"center\" valign=\"middle\">\n";
    if ($cell_counter < $num_of_items) {
      if ($framed)
        display_frame_top($cell_size, $cell_size, 10, "#E7E7E7", $theme);
      $photo = pg_fetch_row($photo_data, $cell_counter);
      $photo[3] = substr($photo[3], 0, 10);
      $photo[4] = substr($photo[4], 0, 10);
      $photo[2] = ereg_replace("\"", "&quot;", $photo[2]);
      $photo[2] = ereg_replace("'", "\'", $photo[2]);
      $photo[2] = ereg_replace("\n", "", $photo[2]);
      $photo[2] = ereg_replace("\r", "", $photo[2]);
      if ($photo[14] != "" && ($photo[15] != "" || $photo[16] != "" || $phot0[17] != "")) { $photo[14] .= ","; }
      if ($photo[15] != "" && ($photo[16] != "" || $photo[17] != "")) { $photo[15] .= ","; }
      if ($photo[16] != "" && ($photo[17] != "")) { $photo[16] .= ","; }
      $location = "$photo[14] $photo[15] $photo[16] $photo[17]";

      if ($popup_enable == 't') {
        $tt_id = "tt_img_$photo[0]";
        echo '<div class="hide_tooltip" id="', $tt_id ,'">',
          '<table cellpadding="0" cellspacing="2" width="100%">';
        print tooltip_row('Title:',    $photo[9]);
        print tooltip_row('Author:',   $photo[10]);
        print tooltip_row('Caption:',  $photo[2]);
	print tooltip_row('Location:', $location);

//        print tooltip_row('Keywords:', $photo[11]);
        print tooltip_row('Exposed:',  $photo[3]);
//        print tooltip_row('Created:',  $photo[4]);
	if ($my_user_id != "" ) {
	  print tooltip_row('Access:',   $photo[5]);
	}
        if ($photo[6] > 0)
          print tooltip_row('Rating:',   round(11 - $photo[6], 3));
        print tooltip_row('Views:',    $photo[7]);
        echo '</table>', "\n",
          '</div>', "\n";
      }

      print "<a class=\"nodecor\" href=\"photo.php?photo=$photo[0]$option\"";
      if ($popup_enable == 't') {
        print "onmouseover=\"this.T_DELAY=$popup_delay; this.T_WIDTH=250; this.T_BORDERCOLOR='$color[tooltip_border]'; this.T_BGCOLOR='$color[tooltip_background]'; return escape(tooltip_text('$tt_id'))\"";
      }
      print "><img src=\"image.display.php?image=$photo[0]&amp;size=1\" alt=\"Image $photo[0]\" /></a>\n";
      if ($framed)
        display_frame_bottom($cell_size, $cell_size, 10, $theme);
    }
    print "</td></tr>\n";

    if (($cell_counter < $num_of_items) && (($my_user_type == $user_type['administrator']) ||
                                             ($my_user_id == $photo[13]) ||
                                             (($photo[8]>0) && ($my_user_type >= $user_type['client']) && ($shop_enable=='t')))) {
      $checkboxes++;
      print "<tr><td align=\"right\">\n";
      print "<input type=\"checkbox\" name=\"cb$cell_counter\" value=\"$photo[0]\"/>\n";
      print "</td></tr>\n";
    }
    print "</table>\n";

    print "</td>\n";
    $rows = $rows + 1;
    if ($rows == $num_of_rows) {
      print "</tr>\n";
      $rows = 0;
    }
  }
  print "</table>\n";
  print "<input type=\"hidden\" name=\"num_of_checkboxes\" value=\"$num_of_items\" />";
  return $checkboxes;
}

function display_photo_list($display_type, $my_user_id, $my_user_type, $container_id, $photo_data, $num_of_items, $shop_enable, $order) {
  global $color;
  global $theme;
  global $user_type;

  $option = "";

  if ($display_type == "album") {
    $option = "&amp;album=$container_id";
  }
  if ($order) {
    $option = "$option&amp;order_by=$order";
  }

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr bgcolor=\"$color[table_top]\"><td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"5\"><font class=\"tabletop\">Photos</font></td></tr>\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"4%\"></td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"56%\">Caption</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Rating</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Access</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Exposure Date</td>\n";
  print "</tr>\n";

  for ($photo_counter = 0; $photo_counter < $num_of_items; $photo_counter++) {
    $photo = pg_fetch_row($photo_data, $photo_counter);
    print "<tr>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"4%\">\n";
    if (($my_user_type == $user_type['administrator']) ||
        ($my_user_id == $photo[13]) ||
        (($photo[8]>0) && ($my_user_type >= $user_type['client']) && ($shop_enable=='t'))) {
      print "<input type=\"checkbox\" name=\"cb$photo_counter\" value=\"$photo[0]\"/>\n";
    }
    print "</td>\n";
    $photo[2] = makeZanza($photo[2], "No caption");
    if ($photo[8] == 1) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"36%\"><a href=\"folder.php?folder=$photo[0]\">$photo[2]</a></td>\n";
    } else {
      $on_mouse_over ="t_w=10; ttWidth=10; return escape('<img src=image.display.php?image=$photo[0]&amp;size=1 border=0/>')";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"36%\"><a href=\"photo.php?photo=$photo[0]$option\" onmouseover=\"$on_mouse_over\">$photo[2]</a></td>\n";
    }

    $photo[6] = round($photo[6], 0);
    if ($photo[6] > 0)
      $photo[6] = 11 - $photo[6];
    else
      $photo[6] = "";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"10%\">$photo[6]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"10%\">$photo[5]</td>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"20%\">".generate_date_html($photo[3], 'date', $my_user_id  == "" ? 0 : 1)."</td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
  print "<input type=\"hidden\" name=\"num_of_checkboxes\" value=\"$num_of_items\" />";
}

function display_lens_string($min_aperture, $max_aperture, $min_focal, $max_focal) {
  if (!$min_aperture)
    return;

  if ($min_aperture == $max_aperture)
    print "$min_aperture";
  else
    print "$min_aperture-$max_aperture";

  if ($min_focal == $max_focal)
    print "/$min_focal";
  else
    print "/$min_focal-$max_focal";

}

function display_folder_combo($identifier, $all_values, $current_value, $kind) {
  $num = pg_num_rows($all_values);
  print "<select name=\"$identifier\">";
  switch ($kind) {
  case "null":
    print "<option value=\"null\">None</option>";
    break;
  case "all":
    print "<option value=\"all\">All Folders</option>";
  }

  if ($all_values != "") {
    $folder_tmp = array();
    for ($i=0; $i < pg_num_rows($all_values); $i++) {
      $folder_tmp[$i] = pg_fetch_array($all_values, $i);
    }

    foreach($folder_tmp as $folder_data) {
      if ($folder_data[2] == null) {
        display_moveto_folder_entry($folder_data, $current_value, 0, "selected");
        display_moveto_recursive($folder_tmp, $folder_data, $current_value, 1, "selected");
      }
    }
  }
  print "</select>";
}


function display_album_combo($identifier, $all_values, $current_value, $kind) {
  $num = pg_num_rows($all_values);
  print "<select name=\"$identifier\">";
  switch ($kind) {
  case "null":
    print "<option value=\"null\">None</option>";
    break;
  case "all":
    print "<option value=\"all\">All Albums</option>";
    break;
  case "null+all":
    print "<option value=\"null\">None</option>";
    print "<option value=\"all\">All Albums</option>";
    break;
  default:
    break;
  }

  if ($all_values != "") {
    $folder_tmp = array();
    for ($i=0; $i < pg_num_rows($all_values); $i++) {
      $folder_tmp[$i] = pg_fetch_array($all_values, $i);
    }

    foreach($folder_tmp as $folder_data) {
      if ($folder_data[2] == null) {
        display_moveto_folder_entry($folder_data, $current_value, 0, "selected");
        display_moveto_recursive($folder_tmp, $folder_data, $current_value, 1, "selected");
      }
    }
  }
  print "</select>";
}

function display_combo($identifier, $all_values, $current_value, $separator, $no_null) {
  $num = pg_num_rows($all_values);
  print "<select name=\"$identifier\">";
  if ($no_null == FALSE) {
    print "<option value=\"null\">None</option>";
  }
  for ($i=0; $i < $num; $i++) {
    $value = pg_fetch_row($all_values, $i);

    if ($value == FALSE) continue;
    if (!isset($value[0])) $value[0] = '';
    if (!isset($value[1])) $value[1] = '';
    if (!isset($value[2])) $value[2] = '';
    if (!isset($value[3])) $value[3] = '';
    if (!isset($value[4])) $value[4] = '';

    if ($value[1] != '' && ($value[2] != '' || $value[3] != '' ||  $value[4] != '')) {
      $value[1] = sprintf("%s%s", $value[1], $separator);
    }
    if ($value[2] != '' && ($value[3] != '' ||  $value[4] != '')) {
      $value[2] = sprintf("%s%s", $value[2], $separator);
    }
    if ($value[3] != '' && $value[4] != '') {
      $value[3] = sprintf("%s%s", $value[3], $separator);
    }
    if ($value[0] == $current_value) {
      print "<option value=\"$value[0]\" selected=\"selected\">$value[1] $value[2] $value[3] $value[4]</option>";
    }
    else {
      print "<option value=\"$value[0]\">$value[1] $value[2] $value[3] $value[4]</option>";
    }
  }
  print "</select>";
}

function display_lens_combo($identifier, $all_values, $current_value, $with_comas, $no_null) {
  $num = pg_num_rows($all_values);
  print "<select name=\"$identifier\">";
  if ($no_null == FALSE) {
    print "<option value=\"null\">None</option>";
  }
  for ($i=0; $i < $num; $i++) {
    $value = pg_fetch_row($all_values, $i);
    if ($with_comas == 1) {
      if ($value[1] != '' && ($value[2] != '' ||  $value[3] != '')) {
        $value[1] = sprintf("%s,", $value[1]);
      }
      if ($value[2] != '' && $value[3] != '') {
        $value[2] = sprintf("%s,", $value[2]);
      }
    }
    if ($value[0] == $current_value) {
      print "<option value=\"$value[0]\" selected=\"selected\">$value[1] $value[2] $value[3]</option>";
    }
    else {
      print "<option value=\"$value[0]\">$value[1] $value[2] $value[3]</option>";
    }
    display_lens_string($value[4], $value[5], $value[6], $value[7]);
  }
  print "</select>";
}


function display_currency_combo($identifier, $all_values, $current_value, $no_null) {
  $num = pg_num_rows($all_values);
  print "<select name=\"$identifier\">";
  if ($no_null == FALSE) {
    print "<option value=\"null\">None</option>";
  }
  for ($i=0; $i < $num; $i++) {
    $value = pg_fetch_row($all_values, $i);
    if ($value[0] == $current_value) {
      print "<option value=\"$value[0]\" title=\"$value[3]\" selected=\"selected\">$value[1] $value[2]</option>";
    }
    else {
      print "<option value=\"$value[0]\" title=\"$value[3]\" >$value[1] $value[2]</option>";
    }
  }
  print "</select>";
}

function display_users($database, $user_list, $viewer_user_id) {
  global $color;
  global $access;
  global $user_type;

  $client = FALSE;

 $viewer_user_data = FALSE;

  if ($viewer_user_id)
    $viewer_user_data = pg_fetch_row(pg_query($database, "select identifier, last_name, first_name, member_since, type from users where users.type>$user_type[client] and identifier=$viewer_user_id"));

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\"   bgcolor=\"$color[table_header]\"  width=\"40%\">Name</td>\n";
  print "<td align=\"center\" bgcolor=\"$color[table_header]\"  width=\"10%\">Photos</td>\n";
  print "<td align=\"center\" bgcolor=\"$color[table_header]\"  width=\"10%\">Folders</td>\n";
  print "<td align=\"center\" bgcolor=\"$color[table_header]\"  width=\"10%\">Albums</td>\n";
  print "<td align=\"center\" bgcolor=\"$color[table_header]\"  width=\"10%\">Equipment</td>\n";
  print "<td align=\"left\"   bgcolor=\"$color[table_header]\"  width=\"20%\">Member Since</td>\n";
  print "</tr>\n";

  if ($viewer_user_data != FALSE) {
    $photos_by_user = pg_fetch_row(pg_query($database, "select count_photos_by_user($viewer_user_data[0])"));
    $folders_by_user = pg_fetch_row(pg_query($database, "select count_folders_by_user($viewer_user_data[0])"));
    $albums_by_user = pg_fetch_row(pg_query($database, "select count_albums_by_user($viewer_user_data[0])"));
    $equipment_by_user = pg_fetch_row(pg_query($database, "select count_equipment_by_user($viewer_user_data[0])"));
    print "<tr>";
    print "<td align=\"left\"   bgcolor=\"$color[table_body]\"  width=\"40%\"><a href=\"user.php?user=$viewer_user_data[0]\">$viewer_user_data[1], $viewer_user_data[2]</a></td>";
    print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$photos_by_user[0]</td>";
    print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$folders_by_user[0]</td>";
    print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$albums_by_user[0]</td>";
    print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$equipment_by_user[0]</td>";
    print "<td align=\"left\"   bgcolor=\"$color[table_body]\"  width=\"20%\">".generate_date_html($viewer_user_data[3], 'date', 1)."</td>";
    print "</tr>";
  }

  $user_count = pg_num_rows($user_list);
  for ($i=0; $i < $user_count; $i++) {
    $user = pg_fetch_row($user_list, $i);
    if ($user[0] != $viewer_user_data[0]) {
      if ($user[0] != "" && $viewer_user_data[0] != "") {
        $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$user[0]' and client='$viewer_user_data[0]' and status=2"));
      }

      if ($viewer_user_data[4] == $user_type['administrator']) {
        $photos_by_user    = pg_fetch_row(pg_query($database, "select count_photos_by_user($user[0])"));
        $folders_by_user   = pg_fetch_row(pg_query($database, "select count_folders_by_user($user[0])"));
        $albums_by_user    = pg_fetch_row(pg_query($database, "select count_albums_by_user($user[0])"));
        $equipment_by_user = pg_fetch_row(pg_query($database, "select count_equipment_by_user($user[0])"));
      }
      else if ($client != FALSE) {
        $photos_by_user    = pg_fetch_row(pg_query($database, "select count_photos_by_user($user[0], $access[protected])"));
        $folders_by_user   = pg_fetch_row(pg_query($database, "select count_folders_by_user($user[0], $access[protected])"));
        $albums_by_user    = pg_fetch_row(pg_query($database, "select count_albums_by_user($user[0], $access[protected])"));
        $equipment_by_user = pg_fetch_row(pg_query($database, "select count_equipment_by_user($user[0], $access[protected])"));
      }
      else {
        $photos_by_user    = pg_fetch_row(pg_query($database, "select count_photos_by_user($user[0], $access[public])"));
        $folders_by_user   = pg_fetch_row(pg_query($database, "select count_folders_by_user($user[0], $access[public])"));
        $albums_by_user    = pg_fetch_row(pg_query($database, "select count_albums_by_user($user[0], $access[public])"));
        $equipment_by_user = pg_fetch_row(pg_query($database, "select count_equipment_by_user($user[0], $access[public])"));
      }

      print "<tr>";
      print "<td align=\"left\"   bgcolor=\"$color[table_body]\"  width=\"40%\"><a href=\"user.php?user=$user[0]\">$user[1], $user[2]</a></td>";
      print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$photos_by_user[0]</td>";
      print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$folders_by_user[0]</td>";
      print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$albums_by_user[0]</td>";
      print "<td align=\"center\" bgcolor=\"$color[table_body]\"  width=\"10%\">$equipment_by_user[0]</td>";
      print "<td align=\"left\"   bgcolor=\"$color[table_body]\"  width=\"20%\">".generate_date_html($user[3], 'date', $viewer_user_data[0] == "" ? 0 : 1)."</td>";
      print "</tr>";
    }
  }
  print "</table>\n";
}

function display_albums($database, $album_id, $viewer_user_id, $viewer_user_type, $owner_user_id, $owner_user_type, $display_header) {
  global $color;
  global $access;
  global $user_type;

  $client = FALSE;

  if ($album_id == FALSE) {
    $selector = "parent_album is null";
  } else {
    $selector = "parent_album=$album_id";
  }

  $album_type = $owner_user_type > $user_type['client'] ? "u" : "c";

  if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) {
    $sql_query_album_access_rights_string = "";
  }
  else {
    if ($owner_user_id != "" && $viewer_user_id != "") {
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_user_id' and client='$viewer_user_id' and status=2"));
    }
    if ($client == FALSE)
      $sql_query_album_access_rights_string = "and access_rights = $access[public]";
    else
      $sql_query_album_access_rights_string = "and access_rights < $access[private]";
  }

  $all_albums = pg_query($database, "
     select album.identifier, caption, date_of_creation, value
       from album, access_type
      where users=$owner_user_id
        and access_type.identifier = album.access_rights
        and album.type = '$album_type'
        and $selector
        $sql_query_album_access_rights_string
      order by date_of_creation desc");

  $num_of_albums = pg_num_rows($all_albums);

  if (($viewer_user_id != $owner_user_id) && ($num_of_albums == 0))
    return;

  print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  if ($display_header == "with_header") {
    print "<tr bgcolor=\"$color[table_top]\">\n";
    if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator']))
      $colspan = 7;
    else
      $colspan = 5;
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"$colspan\"><font class=\"tabletop\">Albums</font></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"46%\">Album Name</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">Subalbums</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"7%\">Size</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Created</td>\n";
  if ($album_type == "u") {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Access</td>\n";
  }
  if ($viewer_user_id == $owner_user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  colspan=\"2\" width=\"10%\">\n";
    print "<a href=\"album.add.php?parent=$album_id\">Add Album</a>";
    print "</td>\n";
  }
  else if ($viewer_user_type == $user_type['administrator']) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\"  colspan=\"2\" width=\"10%\"></td>";
  }
  print "</tr>\n";

  for ($i = 0; $i < $num_of_albums; $i++) {
    $album = pg_fetch_row($all_albums, $i);
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"album.php?album=$album[0]\">$album[1]</a></td>\n";
    if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) {
      $photos_in_album = pg_fetch_row(pg_query($database, "select count_photos_by_album($album[0])"));
      $subalbums_in_album = pg_fetch_row(pg_query($database, "select count_subalbums_by_album($album[0])"));
      print "<td align=\"left\" bgcolor=\"$color[table_body]\">$subalbums_in_album[0]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\">$photos_in_album[0]</td>\n";
    } else {
      if ($client == FALSE) {
        $public_photos_in_album = pg_fetch_row(pg_query($database, "select count_photos_by_album($album[0], $access[public])"));
        $public_subalbums_in_album = pg_fetch_row(pg_query($database, "select count_subalbums_by_album($album[0], $access[public])"));
        print "<td align=\"left\" bgcolor=\"$color[table_body]\">$public_subalbums_in_album[0]</td>\n";
        print "<td align=\"left\" bgcolor=\"$color[table_body]\">$public_photos_in_album[0]</td>\n";
      }
      else {
        $protected_photos_in_album = pg_fetch_row(pg_query($database, "select count_photos_by_album($album[0], $access[protected])"));
        $protected_subalbums_in_album = pg_fetch_row(pg_query($database, "select count_subalbums_by_album($album[0], $access[protected])"));
        print "<td align=\"left\" bgcolor=\"$color[table_body]\">$protected_subalbums_in_album[0]</td>\n";
        print "<td align=\"left\" bgcolor=\"$color[table_body]\">$protected_photos_in_album[0]</td>\n";
      }
    }
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($album[2], 'date', $viewer_user_id == "" ? 0 : 1). "</td>";
    if ($album_type == "u") {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$album[3]</td>\n";
    }
    if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) {
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"5%\"><a href=\"album.edit.php?album=$album[0]\">Edit</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"5%\"><a href=\"album.del.php?album=$album[0]\">Delete</a></td>\n";
    }
    print "</tr>\n";
  }
  print "</table>\n";
}


function display_folders($database, $folder_id, $viewer_user_id, $viewer_user_type, $owner_user_id, $display_header) {
  global $color;
  global $access;
  global $user_type;

  $client=FALSE;

  if ($folder_id == "") {
    $folder_selector = "parent_folder is null";
    $display_special_folders = TRUE;
  } else {
    $folder_selector = "parent_folder=$folder_id";
    $display_special_folders = FALSE;
  }

  if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) {
    $all_folders = pg_query($database, "select folder.identifier, caption, date_of_creation, value from folder, access_type where users=$owner_user_id and access_type.identifier=folder.access_rights and $folder_selector order by date_of_creation desc");
  } else {
    if ($owner_user_id != "" && $viewer_user_id != "") {
      $client = pg_fetch_row(pg_query ($database, "select identifier from client where users='$owner_user_id' and client='$viewer_user_id' and status=2"));
    }
    if ($client == FALSE)
      $all_folders = pg_query($database, "select folder.identifier, caption, date_of_creation, value from folder, access_type where users=$owner_user_id and access_type.identifier=folder.access_rights and folder.access_rights=$access[public] and $folder_selector order by date_of_creation desc");
    else
      $all_folders = pg_query($database, "select folder.identifier, caption, date_of_creation, value from folder, access_type where users=$owner_user_id and access_type.identifier=folder.access_rights and folder.access_rights<$access[private] and $folder_selector order by date_of_creation desc");
  }

  $num_of_folders = pg_num_rows($all_folders);

  if (($viewer_user_id != $owner_user_id) && ($num_of_folders == 0))
    return;

  print "<table bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  if ($display_header == "with_header") {
    print "<tr bgcolor=\"$color[table_top]\">\n";
    if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator']))
      $colspan = 7;
    else
      $colspan = 5;
    print "<td align=\"left\" bgcolor=\"$color[table_top]\" colspan=\"$colspan\"><font class=\"tabletop\">Folders</font></td>\n";
    print "</tr>\n";
  }
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"46%\">Folder Name</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"7%\">Subfolders</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"7%\">Photos</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"20%\">Created</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\" width=\"10%\">Access</td>\n";
  if ($viewer_user_id == $owner_user_id) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\" colspan=\"2\" width=\"10%\">\n";
    print "<a href=\"folder.add.php?parent=$folder_id\">Add Folder</a>\n";
    print "</td>";
  }
  else if ($viewer_user_type == $user_type['administrator']) {
    print "<td align=\"left\" bgcolor=\"$color[table_header]\" colspan=\"2\" width=\"10%\"></td>";
  }
  print "</tr>\n";

  /* trash is not a user folder */
  for ($i = 0; $i < $num_of_folders; $i++) {
    $folder = pg_fetch_row($all_folders, $i);
    if ($folder[1] == "Trash" && $display_special_folders) {
      $photos_in_trash = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[0])"));
      $trash = $folder;
    }
    else if ($folder[1] == "Orphanage" && $display_special_folders) {
      $photos_in_orphanage = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[0])"));
      $orphanage = $folder;
    }
    else {
      print "<tr>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"><a href=\"folder.php?folder=$folder[0]\">$folder[1]</a></td>\n";
      if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) {
        $subfolders_in_folder = pg_fetch_row(pg_query($database, "select count_subfolders_by_folder($folder[0])"));
        print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$subfolders_in_folder[0]</td>\n";
        $photos_in_folder = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[0])"));
        print "<td align=\"left\" bgcolor=\"$color[table_body]\">$photos_in_folder[0]</td>\n";
      } else {
        if ($client == FALSE) {
          $public_subfolders_in_folder = pg_fetch_row(pg_query($database, "select count_subfolders_by_folder($folder[0], $access[public])"));
          print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$public_subfolders_in_folder[0]</td>\n";
          $public_photos_in_folder = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[0], $access[public])"));
          print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$public_photos_in_folder[0]</td>\n";
        } else {
          $protected_subfolders_in_folder = pg_fetch_row(pg_query($database, "select count_subfolders_by_folder($folder[0], $access[protected])"));
          print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$protected_subfolders_in_folder[0]</td>\n";
          $protected_photos_in_folder = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[0], $access[protected])"));
          print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$protected_photos_in_folder[0]</td>\n";
        }
      }
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($folder[2], 'date', $viewer_user_id == "" ? 0 : 1). "</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$folder[3]</td>\n";
      if (($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) {
        print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"folder.edit.php?folder=$folder[0]\">Edit</a></td>\n";
        print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"folder.del.php?folder=$folder[0]\">Delete</a></td>\n";
      }
      print "</tr>\n";
    }
  }
  if ((($viewer_user_id == $owner_user_id) || ($viewer_user_type == $user_type['administrator'])) && $display_special_folders) {
    if ($photos_in_orphanage[0] > 0) {
      print "<tr>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"folder.php?folder=$orphanage[0]\">$orphanage[1]</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"5%\"></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"5%\">$photos_in_orphanage[0]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($orphanage[2], 'date', $viewer_user_id == "" ? 0 : 1). "</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >Private</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  colspan=\"2\"></td>\n";
      print "</tr>\n";
    }
    if ($photos_in_trash[0] > 0) {
      print "<tr>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"folder.php?folder=$trash[0]\">$trash[1]</a></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"5%\"></td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"5%\">$photos_in_trash[0]</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($trash[2], 'date', $viewer_user_id == "" ? 0 : 1). "</td>";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\" >Private</td>\n";
      print "<td align=\"left\" bgcolor=\"$color[table_body]\"  colspan=\"2\"><a href=\"trash.empty.php?user=$owner_user_id\">Empty Trash</a></td>\n";
      print "</tr>\n";
    }
  }
  print "</table>\n";
}

function display_folder_with_users($database, $my_user_id, $folder_list) {
  global $color;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"40%\">Folder</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Size</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Created</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"30%\">User</td>\n";
  print "</tr>\n";

  $user_count = pg_num_rows($folder_list);
  for ($i=0; $i < $user_count; $i++) {
    $folder = pg_fetch_row($folder_list, $i);
    $photos_by_folder = pg_fetch_row(pg_query($database, "select count_photos_by_folder($folder[1])"));
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"folder.php?folder=$folder[1]\">$folder[0]</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$photos_by_folder[0]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($folder[2], 'date', $my_user_id == "" ? 0 : 1). "</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$folder[5]\">$folder[3] $folder[4]</a></td>";
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_album_with_users($database, $my_user_id, $album_list) {
  global $color;

  print "<table align=\"center\" bgcolor=\"$color[table_background]\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" width=\"100%\">\n";
  print "<tr>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"40%\">Album</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"10%\">Size</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"20%\">Created</td>\n";
  print "<td align=\"left\" bgcolor=\"$color[table_header]\"  width=\"30%\">User</td>\n";
  print "</tr>\n";

  $user_count = pg_num_rows($album_list);
  for ($i=0; $i < $user_count; $i++) {
    $album = pg_fetch_row($album_list, $i);
    $photos_by_album = pg_fetch_row(pg_query($database, "select count_photos_by_album($album[1])"));
    print "<tr>\n";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"album.php?album=$album[1]\">$album[0]</a></td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >$photos_by_album[0]</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" >".generate_date_html($album[2], 'date', $my_user_id == "" ? 0 : 1). "</td>";
    print "<td align=\"left\" bgcolor=\"$color[table_body]\" ><a href=\"user.php?user=$album[5]\">$album[3] $album[4]</a></td>";
    print "</tr>\n";
  }
  print "</table>\n";
}

function display_contact_info($database, $my_user_id, $user_id, $display_header) {
  global $color;

  $user_info = pg_fetch_row(pg_query($database, "select first_name, last_name, company, contact, member_since from users where identifier=$user_id"));

  if (!$user_info)
    return;

  $contact_info = pg_fetch_row(pg_query($database, "select address1, address2, city, zipcode, state, country, phone, email, url
                                                      from view_contact_info
                                                     where identifier=$user_info[3]"));

  print "<table cellspacing=\"1\" cellpadding=\"3\" border=\"0\" bgcolor=\"$color[table_background]\" width=\"100%\">\n";
  print "<tr>\n<td align=\"left\"  bgcolor=\"$color[table_top]\" colspan=\"2\"><font class=\"tabletop\">Contact Information</font></td></tr>\n";
  if ($user_info[0] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>First name</td>\n  <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$user_info[0]</td>\n</tr>\n";
  if ($user_info[1] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Last name</td>\n   <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$user_info[1]</td>\n</tr>\n";
  if ($user_info[2] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Company</td>\n     <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$user_info[2]</td>\n</tr>\n";
  if ($contact_info[0] != "" || $contact_info[1] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Address</td>\n     <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$contact_info[0]<br/>$contact_info[1]</td>\n</tr>\n";
  if ($contact_info[2] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>City</td>\n        <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$contact_info[2]</td>\n</tr>\n";
  if ($contact_info[3] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Zipcode</td>\n     <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$contact_info[3]</td>\n</tr>\n";
  if ($contact_info[4] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>State</td>\n       <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$contact_info[4]</td>\n</tr>\n";
  if ($contact_info[5] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Country</td>\n     <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$contact_info[5]</td>\n</tr>\n";
  if ($contact_info[7] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Email</td>\n       <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\"><a href=\"mailto:$contact_info[7]\">$contact_info[7]</a></td>\n</tr>\n";
  if ($contact_info[8] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Website</td>\n     <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\"><a href=\"$contact_info[8]\">$contact_info[8]</a></td>\n</tr>\n";
  if ($contact_info[6] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Phone</td>\n       <td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">$contact_info[6]</td>\n</tr>\n";
  if ($user_info[4] != "")
    print "<tr>\n<td align=\"right\" bgcolor=\"$color[table_header]\"  nowrap>Member since</td>\n<td align=\"left\" bgcolor=\"$color[table_body]\"  width=\"80%\">".generate_date_html($user_info[4], "date", $my_user_id == "" ? 0 : 1). "</td>\n</tr>\n";
  print "</table>\n";
}


function display_label_layout($left_margin, $top_margin, $x_size, $y_size, $x_space, $y_space, $columns, $rows, $show_leading_blanks) {
  print "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
  print "<tr>\n";
  print "<td align=\"center\"  colspan=\"2\">";
  if ($show_leading_blanks)
    print "Leading blanks";
  print "</td>\n";
  print "<td align=\"center\" >Margin</td>\n";
  print "<td align=\"center\" >Width</td>\n";
  print "<td align=\"center\" >Space</td>\n";
  print "<td colspan=\"2\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td colspan=\"7\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td align=\"center\"  colspan=\"2\">";
  if ($show_leading_blanks)
    print "<input type=\"text\" name=\"leading_blanks\" value=\"0\" size=\"6\"/>";
  print "</td>\n";
  print "<td align=\"center\" ><input type=\"text\" name=\"left_margin\" value=\"$left_margin\" size=\"6\"/></td>\n";
  print "<td align=\"center\" ><input type=\"text\" name=\"x_size\" value=\"$x_size\" size=\"6\"/></td>\n";
  print "<td align=\"center\" ><input type=\"text\" name=\"x_space\" value=\"$x_space\" size=\"6\"/></td>\n";
  print "<td colspan=\"2\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td colspan=\"7\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td></td>\n";
  print "<td><img src=\"themes/print.label.11.gif\"/></td>\n";
  print "<td><img src=\"themes/print.label.12.gif\"/></td>\n";
  print "<td><img src=\"themes/print.label.13.gif\"/></td>\n";
  print "<td><img src=\"themes/print.label.14.gif\"/></td>\n";
  print "<td><img src=\"themes/print.label.15.gif\"/></td>\n";
  print "<td></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td align=\"right\" >Margin&nbsp;<input type=\"text\" name=\"top_margin\" value=\"$top_margin\" size=\"6\"/>&nbsp;</td>\n";
  print "<td colspan=\"5\"><img src=\"themes/print.label.21.gif\"/></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td align=\"right\" >Height&nbsp;<input type=\"text\" name=\"y_size\" value=\"$y_size\" size=\"6\"/>&nbsp;</td>\n";
  print "<td colspan=\"5\"><img src=\"themes/print.label.31.gif\"/></td>\n";
  print "<td align=\"center\" >&nbsp;";
  print "<select name=\"rows\">\n";
  for ($i=1; $i < 51; $i++) {
    if ($rows == $i)
      print "<option value=\"$i\" selected=\"selected\">$i</option>";
    else
      print "<option value=\"$i\">$i</option>";
  }
  print "</select>&nbsp;Rows\n";
  print "</td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td align=\"right\" >Space&nbsp;<input type=text name=y_space value=\"$y_space\" size=\"6\"/>&nbsp;</td>\n";
  print "<td colspan=\"5\"><img src=\"themes/print.label.41.gif\"/></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td></td>\n";
  print "<td colspan=\"5\"><img src=\"themes/print.label.51.gif\"/></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td colspan=\"7\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td colspan=\"3\"></td>\n";
  print "<td align=\"center\" >";
  print "&nbsp;<br/>\n";
  print "<select name=\"columns\">\n";
  for ($i=1; $i < 11; $i++) {
    if ($columns == $i)
      print "<option value=\"$i\" selected=\"selected\">$i</option>";
    else
      print "<option value=\"$i\">$i</option>";
  }
  print "</select>\n";
  print "</td>\n";
  print "<td colspan=\"4\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td colspan=\"7\"></td>\n";
  print "</tr>\n";

  print "<tr>\n";
  print "<td colspan=\"3\"></td>\n";
  print "<td align=\"center\" >Columns</td>\n";
  print "<td colspan=\"3\"></td>\n";
  print "</tr>\n";

  print "</table>\n";
}

function makeZanza($string, $default) {
  if ($string) {
    if (strlen($string) > 40) {
      $zanza = substr($string, 0, 40);
      $zanza = $zanza . "...";
    }
    else {
      $zanza = $string;
    }
  }
  else {
    $zanza = $default;
  }
  return $zanza;
}

function display_shaded_photo($photo_url, $link_url, $original_file) {
  global $theme;

  if (is_file($original_file)) {
    $image_size = getimagesize($original_file);
  }
  else {
    $image_size = getimagesize("themes/null.photo.large.gif");
  }

  print "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"bottom\"><img height=\"7\" src=\"$theme/shadow.top.left.gif\" alt=\"\"/></td>\n";
  print "<td align=\"center\" valign=\"bottom\"><img height=\"7\" src=\"$theme/shadow.top.gif\" width=\"$image_size[0]\" alt=\"\"/></td>\n";
  print "<td align=\"left\"   valign=\"bottom\"><img height=\"7\" src=\"$theme/shadow.top.right.gif\" alt=\"\"/></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"middle\"><img src=\"$theme/shadow.left.gif\" width=\"7\" height=\"$image_size[1]\" alt=\"\"/></td>\n";
  print "<td align=\"center\" valign=\"middle\" nowrap>";
  if ($link_url == "")
    print "<img src=\"$photo_url\" alt=\"\"/>";
  else
    print "<a class=\"nodecor\" href=\"$link_url\"><img src=\"$photo_url\" border=\"0\" alt=\"\"/></a>";
  print "</td>\n";
  print "<td align=\"left\"   valign=\"middle\"><img src=\"$theme/shadow.right.gif\" width=\"13\" height=\"$image_size[1]\" alt=\"\"/></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"top\"><img height=\"13\" src=\"$theme/shadow.bottom.left.gif\" alt=\"\"/></td>\n";
  print "<td align=\"center\" valign=\"top\"><img height=\"13\" src=\"$theme/shadow.bottom.gif\" width=\"$image_size[0]\" alt=\"\"/></td>\n";
  print "<td align=\"left\"   valign=\"top\"><img height=\"13\" src=\"$theme/shadow.bottom.right.gif\" alt=\"\"/></td>\n";
  print "</tr>\n";
  print "</table>\n";
}

function display_navigator_box_top($index, $data, $width) {
  global $theme;

  print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" width=\"$width\" border=\"0\">\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"bottom\"><img src=\"$theme/navigator.left.corner.gif\" width=\"8\" height=\"25\" alt=\"\"/></td>\n";
  print "<td align=\"center\" valign=\"middle\" width=\"$width\" height=\"25\" background=\"$theme/navigator.top.gif\">";

  print "<table align=\"center\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n<tr>\n";
  print "<td width=\"10\"><img src=\"$theme/navigator.left.gif\" alt=\"\"/></td>\n";

  $current_index = 1;
  foreach ($data as $item) {
    print "<td width=\"10\"><a class=\"nodecor\" href=\"".$item['link']."\"><img src=\"";
    if ($current_index == $index)
      print $item['active_img'];
    else
      print $item['img'];
    print "\" border=\"0\" alt=\"".$item['alt']."\" /></a></td>\n";
    $current_index++;
  }
  print "<td width=\"10\"><img src=\"$theme/navigator.right.gif\" alt=\"\"/></td>\n";
  print "</tr></table>\n";

  print "</td>\n";
  print "<td align=\"left\"   valign=\"bottom\"><img src=\"$theme/navigator.right.corner.gif\" width=\"8\" height=\"25\" alt=\"\"/></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"middle\" width=\"8\" background=\"$theme/box.left.gif\"></td>\n";
  print "<td align=\"center\" valign=\"middle\">\n";
}

function display_navigator_box_bottom($width) {
  global $theme;

  print "\n</td>\n";
  print "<td align=\"left\"   valign=\"middle\" width=\"8\" background=\"$theme/box.right.gif\"></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=\"right\"  valign=\"top\"><img src=\"$theme/box.bottom.left.gif\"  width=\"8\" height=\"8\" alt=\"\"/></td>\n";
  print "<td align=\"center\" valign=\"top\" width=\"$width\"><img src=\"$theme/box.bottom.gif\"  width=\"$width\" height=\"8\" alt=\"\"/></td>\n";
  print "<td align=\"left\"   valign=\"top\"><img src=\"$theme/box.bottom.right.gif\" width=\"8\" height=\"8\" alt=\"\"/></td>\n";
  print "</tr>\n";
  print "</table>\n";
}

function grant_access_to_original($is_original_present, $is_mine, $is_admin, $is_original_public, $is_it_bought) {
  if (!$is_original_present)
    return false;

  if ($is_mine)
    return true;

  if ($is_admin)
    return true;

  if ($is_original_public)
    return true;

  if ($is_it_bought)
    return true;

  return false;
}

function get_im_composite_options($database, $userid) {
  return pg_fetch_row(pg_query($database, "
  select gravity, watermark, photo, large_image_path
    from imagemagick_composite_options, users, photo_version
   where imagemagick_composite_options.identifier=users.imagemagick_composite_options
     and photo_version.identifier = imagemagick_composite_options.photo_version
     and users.identifier = $userid"));
}

function get_im_options($database, $userid) {
  return  pg_fetch_row(pg_query($database, "
    select preview_quality, preview_colorspace, preview_gamma,
           preview_sharpen_radius, preview_sharpen_sigma,
           preview_border_width, preview_border_height, preview_border_color,
           thumb_quality, thumb_colorspace, thumb_gamma,
           thumb_sharpen_radius, thumb_sharpen_sigma,
           thumb_border_width, thumb_border_height, thumb_border_color,
           preview_sharpen_amount, preview_sharpen_threshold,
           thumb_sharpen_amount, thumb_sharpen_threshold
      from imagemagick_options, users
     where imagemagick_options.identifier=users.imagemagick_options
       and users.identifier=$userid"));
}
function get_dcraw_options($database, $userid) {
  return  pg_fetch_row(pg_query($database, "
    select gamma, brightness, white_balance, bitdepth
      from dcraw_options, users
     where users.dcraw_options = dcraw_options.identifier
       and users.identifier = $userid"));
}

// See http://sylvana.net/jpegcrop/exif_orientation.html for an explanation of these numbers

function map_transform($orientation, $transform) {
	switch ($transform) {
		case 'r90':
			switch ($orientation) {
				case 1:
					return 8;
				case 2:
					return 7;
				case 3:
					return 6;
				case 4:
					return 5;
				case 5:
					return 2;
				case 6:
					return 1;
				case 7:
					return 4;
				case 8:
					return 3;
				default:
			}
			break;
		case 'r180':
			switch ($orientation) {
				case 1:
					return 3;
				case 2:
					return 4;
				case 3:
					return 1;
				case 4:
					return 2;
				case 5:
					return 7;
				case 6:
					return 8;
				case 7:
					return 5;
				case 8:
					return 6;
				default:
			}
			break;
		case 'r270':
			switch ($orientation) {
				case 1:
					return 6;
				case 2:
					return 5;
				case 3:
					return 8;
				case 4:
					return 7;
				case 5:
					return 4;
				case 6:
					return 3;
				case 7:
					return 2;
				case 8:
					return 1;
				default:
			}
			break;
		case 'flip':
			switch ($orientation) {
				case 1:
					return 4;
				case 2:
					return 3;
				case 3:
					return 2;
				case 4:
					return 1;
				case 5:
					return 6;
				case 6:
					return 5;
				case 7:
					return 8;
				case 8:
					return 7;
				default:
			}
			break;
		case 'flop':
			switch ($orientation) {
				case 1:
					return 2;
				case 2:
					return 1;
				case 3:
					return 4;
				case 4:
					return 3;
				case 5:
					return 8;
				case 6:
					return 7;
				case 7:
					return 6;
				case 8:
					return 5;
				default:
			}
			break;
		default:
        }

	return $orientation;
}

/* Add a folder to the database */
function add_folder($database, $userid, $parent, $access_rights, $name, $descr, $order_by)
{
  $name = pg_escape_string($name);
  $descr = pg_escape_string($descr);

  if (($name != "") && 
      ($name != "Trash") &&
      ($name != "Orphanage")) {

    $string = "insert into folder (identifier, parent_folder, users, caption, description, date_of_creation, access_rights, orderby)
                                 values (nextval('folder_id_sequence'), $parent, 
$userid, '$name', '$descr', now(), $access_rights, $order_by)";

#    print("<pre>$string</pre>\n");
    $result = pg_query($database, $string);

    return ($result != FALSE);
  } else {
    return FALSE;
  }
}

function semi_string_to_array($str){
   $expr="/;(?=(?:[^\"]*\"[^\"]*\")*(?![^\"]*\"))/";
   $results=preg_split($expr,trim($str));
   return preg_replace("/^\"(.*)\"$/","$1",$results);
}
function space_string_to_array($str){
   $expr="/ (?=(?:[^\"]*\"[^\"]*\")*(?![^\"]*\"))/";
   $results=preg_split($expr,trim($str));
   return preg_replace("/^\"(.*)\"$/","$1",$results);
}

function po_get_image_size($file) {
  global $sys_exiftool;

  if (!is_executable($sys_exiftool)) 
    return getimagesize($file);

  $width = FALSE;
  $height = FALSE;

  $handle = popen("$sys_exiftool -ImageWidth -ImageHeight $file", "r");
  if ($handle) {
    while (!feof($handle)) {
      $line = fgets($handle);
      $parts = explode(":", $line, 2);
      $parts[0] = trim($parts[0]);
      if (!isset($parts[1])) continue;
      $parts[1] = trim($parts[1]);
      if ($parts[0] == "Image Width") $width = $parts[1];
      if ($parts[0] == "Image Height") $height = $parts[1];
      print "<!-- XXX $parts[0] : $parts[1] -- $width $height -->\n";
    }
    pclose($handle);
  }

  if (!$width || !$height)
    return getimagesize($file);
  
  return array($width,$height);

}

?>
