<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

// Mime Type Conversion - since browsers aren't capable of displaying
// many of the file types that can be processed by the system at upload.
// We generate the thumbnail and the preview in JPEG or at your preference in PNG.
// You can specify for each format apart in which format you prefer
// for the preview or the thumbnail by setting the "out" parameter

include_once "include/config.php";

$mime_type = array (
// FILE               MIME                     IMAGICK MULTI    THUMBNAIL AND    RAW
// EXTENSION          TYPE                     PAGE PARAMETER   PREVIEW FORMAT   DECODER               POSTPROCESSOR                  DESCRIPTION
  "8bim"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Photoshop resource format"),
  "8bimtext"=> array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Photoshop resource format"),
  "app1"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Raw application information"),
  "art"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "PF1: 1st Publisher"),
  "avi"     => array ("type" => "application", "page" => "[9]", "out" => "jpeg", "decoder" => "",               "name" => "Audio/Visual Interleaved"),
  "avs"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "AVS X image"),
  "bie"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Joint Bi-level Image experts Group interchange format"),
  "bmp"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Microsoft Windows bitmap image"),
  "cmyk"    => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Raw cyan, magenta, yellow, and black samples"),
  "cmyka"   => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Raw cyan, magenta, yellow, black, and opacity samples"),
  "crw"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Canon Raw Format"),
  "cr2"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Canon Raw Format 2"),
  "cut"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "DR Halo"),
  "dcm"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Digital Imaging and Communications in Medicine image"),
  "dcr"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Kodak Raw Format"),
  "kdc"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Kodak Digital Camera Raw Format"),
  "dcx"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "ZSoft IBM PC multi-page Paintbrush"),
  "dps"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Display Postscript"),
  "dpx"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Digital Moving Picture Exchange"),
  "epdf"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Encapsulated Portable Document Format"),
  "epi"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Adobe Encapsulated PostScript Interchange format"),
  "eps"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Adobe Encapsulated PostScript"),
  "epsf"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Adobe Encapsulated PostScript"),
  "epsi"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Adobe Encapsulated PostScript Interchange format"),
  "ept"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Adobe Encapsulated PostScript with TIFF preview"),
  "fax"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Group 3 FAX"),
  "fits"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Flexible Image Transport System"),
  "fpx"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "FlashPix Format"),
  "g3"      => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Group 3 FAX"),
  "gif"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "CompuServe graphics interchange format (LZW disabled)"),
  "gif87"   => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "CompuServe graphics interchange format (version 87a)"),
  "gray"    => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Raw gray samples"),
  "hdf"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Hierarchical Data Format"),
  "icb"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Truevision Targa image"),
  "icm"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "ICC Color Profile"),
  "ico"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Microsoft icon"),
  "icon"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Microsoft icon"),
  "iptc"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "IPTC Newsphoto"),
  "jbg"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Joint Bi-level Image experts Group interchange format"),
  "jbig"    => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Joint Bi-level Image experts Group interchange format"),
  "jp2"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "JPEG-2000 JP2 File Format Syntax"),
  "jpc"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "JPEG-2000 Code Stream Syntax"),
  "jpeg"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Joint Photographic Experts Group JFIF format (62)"),
  "jpg"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Joint Photographic Experts Group JFIF format"),
  "m2v"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "MPEG Video Stream"),
  "mat"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "MATLAB image format"),
  "miff"    => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Magick Image File Format (5.4.7 with Zlib 1.1.4 and BZlib)"),
  "mng"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Multiple-image Network Graphics (1.2.2)"),
  "mono"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Bi-level bitmap in least-significant-byte first order"),
  "mpeg"    => array ("type" => "application", "page" => "[9]", "out" => "jpeg", "decoder" => "",               "name" => "MPEG Video Stream"),
  "mpg"     => array ("type" => "application", "page" => "[9]", "out" => "jpeg", "decoder" => "",               "name" => "MPEG Video Stream"),
  "mrw"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Minolta Raw Format"),
  "mtv"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "MTV Raytracing image format"),
  "mvg"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Magick Vector Graphics"),
  "nef"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Nikon Raw Format"),
  "orf"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Olympus Raw Format"),
  "raw"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Panasonic raw Image"),
  "p7"      => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Xv thumbnail format"),
  "pef"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Pentax Electronic Format"),
  "pal"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "16bit/pixel interleaved YUV"),
  "palm"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Palm pixmap"),
  "pbm"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Portable bitmap format (black and white)"),
  "pcd"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Kodak Photo CD"),
  "pcds"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Kodak Photo CD"),
  "pct"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Apple Macintosh QuickDraw/PICT"),
  "pcx"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "ZSoft IBM PC Paintbrush"),
  "pdb"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Palm Database ImageViewer Format"),
  "pdf"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Portable Document Format"),
  "pfa"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "TrueType font"),
  "pfb"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "TrueType font"),
  "pgm"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Portable graymap format (gray scale)"),
  "picon"   => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Personal Icon"),
  "pict"    => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Apple Macintosh QuickDraw/PICT"),
  "pix"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Alias/Wavefront RLE image format"),
  "pm"      => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "X Windows system pixmap (color)"),
  "png"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Portable Network Graphics (1.2.2)"),
  "pnm"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Portable anymap"),
  "ppm"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Portable pixmap format (color)"),
  "ps"      => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Adobe PostScript"),
  "psd"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Adobe Photoshop bitmap"),
  "ptif"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Pyramid encoded TIFF"),
  "pwp"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Seattle Film Works"),
  "raf"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",  "name" => "Fuji Raw Format"),
  "ras"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "SUN Rasterfile"),
  "rgb"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Raw red, green, and blue samples"),
  "rgba"    => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Raw red, green, blue, and matte samples"),
  "rla"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Alias/Wavefront image"),
  "rle"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Utah Run length encoded image"),
  "sfw"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Seattle Film Works"),
  "sgi"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Irix RGB image"),
  "stegano" => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Steganographic image"),
  "sun"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "SUN Rasterfile"),
  "srf"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Sony Raw Format"),
  "sr2"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Sony Raw Format 2"),
  "arw"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Sony Alpha Raw format"),
  "svg"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Scalable Vector Gaphics (XML 2.5.1)"),
  "text"    => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Text"),
  "tga"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Truevision Targa image"),
  "tif"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Tagged Image File Format (42)"),
  "tiff"    => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Tagged Image File Format (42)"),
  "tile"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Tile image with a texture"),
  "tim"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "PSX TIM"),
  "ttf"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "TrueType font"),
  "txt"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Text"),
  "uyvy"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "16bit/pixel interleaved YUV"),
  "vda"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Truevision Targa image"),
  "vicar"   => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "VICAR rasterfile format"),
  "vid"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Visual Image Directory"),
  "viff"    => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Khoros Visualization image"),
  "vst"     => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Truevision Targa image"),
  "wbmp"    => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Wireless Bitmap (level 0) image"),
  "wpg"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Word Perfect Graphics"),
  "x"       => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "X Image"),
  "x3f"     => array ("type" => "application", "page" => "",    "out" => "jpeg", "decoder" => "$raw_decoder",          "name" => "Sigma raw Image"),
  "xbm"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "X Windows system bitmap (black and white)"),
  "xc"      => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "Constant image uniform color"),
  "xcf"     => array ("type" => "application", "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "GIMP image"),
  "xpm"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "X Windows system pixmap (color)"),
  "xv"      => array ("type" => "image",       "page" => "[0]", "out" => "jpeg", "decoder" => "",               "name" => "Khoros Visualization image"),
  "xwd"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "X Windows system window dump (color)"),
  "yuv"     => array ("type" => "image",       "page" => "",    "out" => "jpeg", "decoder" => "",               "name" => "CCIR 601 4:1:1 or 4:2:2"));
?>
