<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

//  Try to turn off caching
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/import.php";
include_once "include/common.php";
include_once "include/site.php";

$compress_pages = false;   /* Explicitly disable it here */

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$preferences = pg_fetch_row(pg_query($database, "
  select bulk_upload_enable
    from users, preferences
   where preferences.identifier=users.preferences
     and users.identifier=$po_user[id]"));

$im_options = get_im_options($database, $po_user['id']);
$im_composite_options = get_im_composite_options($database, $po_user['id']);
$dcraw_options = get_dcraw_options($database, $po_user['id']);

$user_name          = pg_fetch_row(pg_query($database, "select first_name, last_name, identifier from users where identifier=$po_user[id]"));
$default_folder_id  = pg_escape_string($_REQUEST['folder']);

$file_name          = $_FILES['file_name']['name'][0];
$file_size          = $_FILES['file_name']['size'][0];
$file_name_tmp      = $_FILES['file_name']['tmp_name'][0];
$original_file_type = strtolower(substr($file_name, strrpos($file_name, ".") + 1));

$local_path         = $_REQUEST['local_path'];

if ($local_bulk_upload && $local_path) {
     $original_file_type = "local";
}

$current_tag = "not_implemented";
$character_data =  "";

function load_default_image_data_values($default_folder) {
  $image_data = array ("num_of_files"           => 0,
                       "file"                   => array(0 => array("name" => "", "name_tmp" => "", "type" => "", "remark" => "", "master" => "")),
                       "folder"                 => $default_folder,
                       "author"                 => pg_escape_string($_REQUEST['author']),
                       "title"                  => pg_escape_string($_REQUEST['title']),
                       "caption"                => pg_escape_string($_REQUEST['caption']),
                       "caption_writer"         => pg_escape_string($_REQUEST['caption_writer']),
                       "web_statement"          => pg_escape_string($_REQUEST['web_statement']),
                       "copyright"              => pg_escape_string($_REQUEST['copyright']),
                       "supplemental_category"  => pg_escape_string($_REQUEST['supplemental_category']),
                       "category"               => substr(pg_escape_string($_REQUEST['category']), 0, 3),
                       "credit"                 => pg_escape_string($_REQUEST['credit']),
                       "source"                 => pg_escape_string($_REQUEST['source']),
                       "headline"               => pg_escape_string($_REQUEST['headline']),
                       "instructions"           => pg_escape_string($_REQUEST['instructions']),
                       "transmission_reference" => pg_escape_string($_REQUEST['transmission_reference']),
                       "date_of_exposure"       => check_date_validity($_REQUEST['exposure_timestamp']),
                       "location"               => pg_escape_string($_REQUEST['location']),
                       "storage_location_type"  => pg_escape_string($_REQUEST['storage_location_type']),
                       "storage_location_id"    => pg_escape_string($_REQUEST['storage_location_id']),
                       "storage_index"          => pg_escape_string($_REQUEST['storage_index']),
                       "access_rights"          => pg_escape_string($_REQUEST['access_rights']),
                       "hide_original"          => pg_escape_string($_REQUEST['hide_original']),
                       "camera"                 => pg_escape_string($_REQUEST['camera']),
                       "lens"                   => pg_escape_string($_REQUEST['lens']),
                       "filter"                 => pg_escape_string($_REQUEST['filter']),
                       "film"                   => pg_escape_string($_REQUEST['film']),
                       "flash"                  => pg_escape_string($_REQUEST['flash']),
                       "scanner"                => pg_escape_string($_REQUEST['scanner']),
                       "focal_length"           => pg_escape_string($_REQUEST['focal_length']),
                       "aperture"               => pg_escape_string($_REQUEST['aperture']),
                       "shutter"                => pg_escape_string($_REQUEST[')shutter']),
		       "exp_comp"               => pg_escape_string($_REQUEST['exp_comp']),
                       "exp_diff"               => pg_escape_string($_REQUEST['exp_diff']),
                       "camera_metering"        => pg_escape_string($_REQUEST['camera_metering']),
                       "camera_program"         => pg_escape_string($_REQUEST['camera_program']),
                       "flash_mode"             => pg_escape_string($_REQUEST['flash_mode']),
                       "flash_comp"             => pg_escape_string($_REQUEST['flash_comp']),
                       "scan_resolution"        => pg_escape_string($_REQUEST['scan_resolution']),
                       "scan_bitdepth"          => pg_escape_string($_REQUEST['scan_bitdepth']),
                       "scan_multiscan"         => pg_escape_string($_REQUEST['scan_multiscan']),
                       "iso_override"           => pg_escape_string($_REQUEST['iso_override']),
                       "support"                => pg_escape_string($_REQUEST['support']),
                       "orientation"            => 0,
                       "decode_exif"            => $_REQUEST['decode_exif'],
                       "decode_iptc"            => $_REQUEST['decode_iptc'],
                       "decode_rdf"             => $_REQUEST['decode_rdf'],
                       "colorspace"             => pg_escape_string($_REQUEST['colorspace']),
                       "keywords"               => $_REQUEST['keywords'],
                       "exif"                   => "",
                       "iptc"                   => "");

  if ($image_data['keywords'] != "") {
    if (strstr($image_data['keywords'], ";")) {
      $image_data['keywords'] = semi_string_to_array($image_data['keywords']);
    } else {
      $image_data['keywords'] = space_string_to_array($image_data['keywords']);
    }
  }

  return $image_data;
}

function XML_StartElement($parser, $name, $attribs) {
  global $image_data;
  global $current_folder;
  global $temporary_directory;
  global $database;
  global $current_tag;
  global $default_folder_id;

  switch ($name) {
  case "BULKUPLOAD":
    break;
  case "FOLDER":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $current_folder = $value;
        }
      }
    }
    break;
  case "PHOTO":
    $image_data = load_default_image_data_values($default_folder_id);
    $image_data['folder'] = $current_folder;
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "TITLE":
          $image_data['title'] = $value;
	  $image_data['IgnoreExifUserComment'] = TRUE;
          break;
        }
      }
    }
    break;

  case "AUTHOR":
    $current_tag = "author";
    break;
  case "KEYWORD":
    $current_tag = "keyword";
    break;
  case "CAPTION":
    $current_tag = "caption";
    break;
  case "COPYRIGHT":
    $current_tag = "copyright";
    break;
  case "CAPTION_WRITER":
    $current_tag = "caption_writer";
    break;
  case "CATEGORY":
    $current_tag = "category";
    break;
  case "CREDIT":
    $current_tag = "credit";
    break;
  case "SOURCE":
    $current_tag = "source";
    break;
  case "HEADLINE":
    $current_tag = "headline";
    break;
  case "INSTRUCTIONS":
    $current_tag = "instructions";
    break;
  case "TRANSMISSION_REFERENCE":
    $current_tag = "transmission_reference";
    break;
  case "SUPPLEMENTAL_CATEGORY":
    $current_tag = "supplemental_category";
    break;
  case "WEB_STATEMENT":
    $current_tag = "web_statement";
    break;

  case "FILE":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "NAME":
          $image_data['file'][$image_data['num_of_files']]['name']     = $temporary_directory . "/" . $value;
          $image_data['file'][$image_data['num_of_files']]['name_tmp'] = $temporary_directory . "/" . $value;
          $image_data['file'][$image_data['num_of_files']]['type']     = strtolower(substr($value, strrpos($value, ".") + 1));
          break;
        case "REMARK":
          $image_data['file'][$image_data['num_of_files']]['remark']   = $value;
          break;
        case "MASTER":
          $image_data['file'][$image_data['num_of_files']]['master']   = ($value == "yes") ? "t" : "f";
          break;
        }
      }
    }
    $image_data['num_of_files']++;;
    break;
  case "EXPDATE":
    $today = getdate(time());
    $year  = $today["year"];
    $month = $today["month"];
    $day   = $today["day"];
    $hour  = $today["hours"];
    $min   = $today["minutes"];
    $sec   = $today["seconds"];
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "YEAR":
          $year = $value;
          break;
        case "MONTH":
          $month = $value;
          break;
        case "DAY":
          $day = $value;
	  break;
        case "HOURS":
          $hour = $value;
	  break;
        case "MINUTES":
          $min = $value;
	  break;
        case "SECONDS":
          $min = $value;
	  break;
        }
      }
      $image_data['date_of_exposure'] = sprintf("%04d-%02d-%02d", $year, $month, $day);
    }
    break;
  case "LOCATION":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['location'] = $value;
        }
      }
    }
    break;
  case "STORAGE":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "TYPE":
          $image_data['storage_location_type'] = $value;
          break;
        case "ID":
          $image_data['storage_location_id'] = $value;
          break;
        case "IDX":
          $image_data['storage_index'] = $value;
        }
      }
    }
    break;
  case "ACCESS":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "TYPE":
          $image_data['access_rights'] = $value;
          break;
        case "ORIGINAL":
          switch ($value) {
          case "owner":
            $image_data['hide_original'] = 't';
            break;
          case "all":
            $image_data['hide_original'] = 'f';
            break;
          }
        }
      }
    }
    break;
  case "CAMERA":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['camera'] = $value;
          break;
        case "METER":
          switch ($value) {
          case "spot":
            $image_data['camera_metering'] = 1;
            break;
          case "center":
            $image_data['camera_metering'] = 2;
            break;
          case "matrix":
            $image_data['camera_metering'] = 3;
            break;
          case "colormatrix":
            $image_data['camera_metering'] = 4;
            break;
          case "zone":
            $image_data['camera_metering'] = 5;
          }
          break;
        case "PROG":
          switch ($value) {
          case "auto":
            $image_data['camera_program'] = 1;
            break;
          case "aperture":
            $image_data['camera_program'] = 2;
            break;
          case "shutter":
            $image_data['camera_program'] = 3;
            break;
          case "manual":
            $image_data['camera_program'] = 4;
          }
          break;
        case "SPEED":
          $shutter_id = pg_fetch_row(pg_query($database, "select identifier from shutter where value='$value'"));
          if ($shutter_id)
            $image_data['shutter'] = $shutter_id[0];
          break;
        case "COMP":
          $exp_comp_id = pg_fetch_row(pg_query($database, "select identifier from ev_comp where value='$value'"));
          if ($exp_comp_id)
            $image_data['exp_comp'] = $exp_comp_id[0];
          break;
        case "EVDIFF":
          $ev_diff_id = pg_fetch_row(pg_query($database, "select identifier from ev_comp where value='$value'"));
          if ($ev_diff_id)
            $image_data['exp_diff'] = $ev_diff_id[0];
        }
      }
    }
    break;
  case "LENS":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['lens'] = $value;
          break;
        case "FOCAL":
          $focal_id = pg_fetch_row(pg_query($database, "select identifier from focal_length where value='$value'"));
          if ($focal_id)
            $image_data['focal_length'] = $focal_id[0];
          break;
        case "APERT":
          $aperture_id = pg_fetch_row(pg_query($database, "select identifier from aperture where value='$value'"));
          if ($aperture_id)
            $image_data['aperture'] = $aperture_id[0];
        }
      }
    }
    break;
  case "FILTER":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['filter'] = $value;
        }
      }
    }
    break;
  case "FILM":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['film'] = $value;
          break;
        case "OVERRIDE":
          $film_iso_override = pg_fetch_row(pg_query($database, "select identifier from film_iso where value='$value'"));
          if ($film_iso_override)
            $image_data['iso_override'] = $film_iso_override[0];
          break;
        }
      }
    }
    break;
  case "FLASH":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['flash'] = $value;
          break;
        case "MODE":
          switch ($value) {
          case "normal":
            $image_data['flash_mode'] = 1;
            break;
          case "slow":
            $image_data['flash_mode'] = 2;
            break;
          case "rear":
            $image_data['flash_mode'] = 3;
          }
          break;
        case "COMP":
          $flash_comp_id = pg_fetch_row(pg_query($database, "select identifier from ev_comp where value='$value'"));
          if ($flash_comp_id)
            $image_data['flash_comp'] = $flash_comp_id[0];
        }
      }
    }
    break;
  case "SCANNER":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['scanner'] = $value;
          break;
        case "DPI":
          $dpi_id = pg_fetch_row(pg_query($database, "select identifier from scan_resolution where value='$value'"));
          if ($dpi_id)
            $image_data['scan_resolution'] = $dpi_id[0];
          break;
        case "BITDEPTH":
          $bitdepth_id = pg_fetch_row(pg_query($database, "select identifier from scan_bitdepth where value='$value'"));
          if ($bitdepth_id)
            $image_data['scan_bitdepth'] = $bitdepth_id[0];
          break;
        case "PASS":
          $multiscan_id = pg_fetch_row(pg_query($database, "select identifier from scan_multiscan where value='$value'"));
          if ($multiscan_id)
            $image_data['scan_multiscan'] = $multiscan_id[0];
        }
      }
    }
    break;
  case "SUPPORT":
    if (sizeof($attribs)) {
      while (list($attribute, $value) = each($attribs)) {
        switch ($attribute) {
        case "ID":
          $image_data['support'] = $value;
        }
      }
    }
  }
}

function XML_CharacterData($parser, $data) {
  global $character_data;
  $character_data = $data;
}

function XML_EndElement($parser, $name) {
  global $image_data;
  global $database;
  global $thumb_max_size;
  global $image_max_size;
  global $default_folder_id;
  global $im_options;
  global $im_composite_options;
  global $dcraw_options;
  global $po_user;
  global $character_data;
  global $current_tag;

  switch ($name) {
  case "PHOTO":
    /* check for the master version and if found upload it */
    $photo_master_id = false;
    for ($index = 0; $index < $image_data['num_of_files']; $index++) {
      if ($image_data['file'][$index]['master'] == 't')
        $photo_master_id = photo_import($database, $index, $im_options, $im_composite_options, $dcraw_options, $po_user['id'], $default_folder_id, $image_data);
    }

    for ($index = 0; $index < $image_data['num_of_files']; $index++) {
      /* upload all other photos as versions */
      if ($image_data['file'][$index]['master'] != 't') {
        /* if no master was found in the first round, default the first photo as the master */
        if (!$photo_master_id)
          $photo_master_id = photo_import($database, $index, $im_options, $im_composite_options, $dcraw_options, $po_user['id'], $default_folder_id, $image_data);
        else {
          $image_data['file'][$index]['master'] = 'f';
          photo_version_import($database, $index, $im_options, $im_composite_options, $dcraw_options, $po_user['id'], $photo_master_id, $image_data);
        }
      }
    }
    $image_data = load_default_image_data_values($default_folder_id);
    break;
  case "AUTHOR":
    $image_data['author'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "KEYWORD":
    $image_data['keywords'][] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CAPTION":
    $image_data['caption'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "COPYRIGHT":
    $image_data['copyright'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CAPTION_WRITER":
    $image_data['caption_writer'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CATEGORY":
    $image_data['category'] = substr($character_data, 0, 3);
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "CREDIT":
    $image_data['credit'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "SOURCE":
    $image_data['source'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "HEADLINE":
    $image_data['headline'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "INSTRUCTIONS":
    $image_data['instructions'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "TRANSMISSION_REFERENCE":
    $image_data['transmission_reference'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "SUPPLEMENTAL_CATEGORY":
    $image_data['supplemental_category'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
    break;
  case "WEB_STATEMENT":
    $image_data['web_statement'] = $character_data;
    $current_tag = "not_implemented";
    $character_data = "";
  }
}

function XML_EndTestElement($parser, $name) {
  switch ($name) {
  case "PHOTO":
    print ".";
    break;
  }
}

function parse_XML($xml_path) {
  print "Looking for the <b>data.xml</b> file ... ";
  if (is_file($xml_path . "/data.xml")) {
    $fp = fopen($xml_path . "/data.xml", "r");
    print "found.\n<br/>\n";
    print "Validating XML file:  ";
    
    /* first parse the xml file  */
    fseek ($fp, 0 ,SEEK_SET);
    $xml_parser = xml_parser_create();
    xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
    xml_set_element_handler($xml_parser, "XML_StartElement", "XML_EndTestElement");
    
    $data = fread($fp, filesize($xml_path . "/data.xml"));
    if (!xml_parse($xml_parser, $data)) {
      print sprintf("<font color=\"red\">%s, XML error: %d %s in file data.xml at line %d</font>\n<p>\n",
		    $data,
		    xml_get_error_code($xml_parser),
		    xml_error_string(xml_get_error_code($xml_parser)),
		    xml_get_current_line_number($xml_parser));
      xml_parser_free($xml_parser);
      fclose($fp);
      exit;
    }
    
    xml_parser_free($xml_parser);
    
    print " well formed.<br/>";
    print "&nbsp;<br/>";
    
    /* now do a real upload as described in the xml file */
    fseek ($fp, 0 ,SEEK_SET);
    
    $xml_parser = xml_parser_create();
    xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, TRUE);
    xml_set_element_handler($xml_parser, "XML_StartElement", "XML_EndElement");
    xml_set_character_data_handler($xml_parser, "XML_CharacterData");
    
    while ($data = fread($fp, 4096)) {
      if (!xml_parse($xml_parser, $data, feof($fp))) {
	print sprintf("<font color=\"red\">XML error: %d %s in file data.xml at line %d</font>\n<p>\n",
		      xml_get_error_code($xml_parser),
		      xml_error_string(xml_get_error_code($xml_parser)),
		      xml_get_current_line_number($xml_parser));
	xml_parser_free($xml_parser);
	fclose($fp);
	exit;
      }
    }
    
    xml_parser_free($xml_parser);
    
    if (!fclose($fp)) {
      print "Failed to close XML document";
    }
  } else {
    print "not found.\n<br/>\n";
    print "&nbsp;<br/>";
  }
}

function upload_directory($database, $upload_path, $user_id, $target_folder, $im_options, $im_composite_options, $dcraw_options) {
  parse_XML($upload_path);
  
  $files = array();
  $i = 0;

  /* upload the rest of the files which where not described in the xml file */
  if ($handle = opendir($upload_path)) {
    while (false !== ($file_name = readdir($handle))) {
      $files[$i++] = $file_name;
    }
    closedir($handle);
    sort($files);

    /* create an array to store the master versions of each photo */
    $master_versions = array();
    foreach($files as $file_name) {
      if ($file_name == "." || $file_name == "..")
	continue;
      if (is_dir($upload_path . "/" . $file_name)) {
	/* Look for an existing folder which matches */
	$data = pg_fetch_row(pg_query($database, "select identifier from folder where parent_folder = $target_folder and caption = '" .pg_escape_string($file_name) ."'"));
	if ($data == null) {
	  global $default_order_by;
	  print "Creating a new sub-folder <b>'$file_name'</b> ... \n";
	  $result = add_folder($database, $user_id, $target_folder, $_REQUEST['access_rights'], $file_name, "", $default_order_by);
	  if (!$result) {
	    $new_folder = $target_folder;
	    print "<font color=\"red\">Failed</font>";
	  } else {
	    /* Figure out new folder ID */
	    $data = pg_fetch_row(pg_query($database, "select identifier from folder where parent_folder = $target_folder and caption = '" .pg_escape_string($file_name) ."'"));
	    $new_folder = $data[0];
	  }
	  print "<br/>";
	} else {
	  $new_folder = $data[0];
	}

	upload_directory($database, $upload_path . "/" . $file_name, $user_id, $new_folder, $im_options, $im_composite_options, $dcraw_options);
	continue;
      }
      $file_type = substr($file_name, strrpos($file_name, ".") + 1);
      if ($file_type == "xml"   || $file_type == "gz"  ||
	  $file_type == "tgz"   || $file_type == "zip" ||
	  $file_type == "bz2"   || $file_type == "tar" ||
	  $file_type == "bzip2" || preg_match("/thumbs.db/i", $file_name)) {
	unlink($upload_path. "/" . $file_name);
	continue;
      }
      
      $image_data = load_default_image_data_values($target_folder);
      $image_data['file'][0]['name']     = $upload_path . "/" . $file_name;
      $image_data['file'][0]['name_tmp'] = $upload_path . "/" . $file_name;
      $image_data['file'][0]['type']     = $file_type;
      $image_data['file'][0]['remark']   = "";
      $image_data['file'][0]['master']   = "t";
      $image_data['num_of_files'] = 1;
    
      $file_name_root = substr($file_name, 0, strrpos($file_name, "."));
      if (!$file_name_root) {
	/* if no dot was found, upload it as a master version */
	$file_name_root = $file_name;
	$master_versions[$file_name_root] = photo_import($database, 0, $im_options, $im_composite_options, $dcraw_options, $user_id, $target_folder, $image_data);
      } else {
	if (!$master_versions[$file_name_root]) {
	  $master_versions[$file_name_root] = photo_import($database, 0, $im_options, $im_composite_options, $dcraw_options, $user_id, $target_folder, $image_data);
	} else {
	  photo_version_import($database, 0, $im_options, $user_id, $im_composite_options, $dcraw_options, $master_versions[$file_name_root], $image_data);
	}
      }
    }
  }

  //  if ($original_file_type != "local") {
    print "Removing temporary directory <b>$upload_path</b> ... ";
    if (!rmdir($upload_path)) {
      print "<font color=\"red\">failed</font> [rmdir $upload_path]<br/>";
    } else {
      print "done.<br/>";
      print "&nbsp;<br/>";
    }
    //  } else {
    //    print "done.<br/>";
    //    print "&nbsp;<br/>";
    //  }
}

site_header($page_width, "Import Photos");
site_navigator(5);
$path_to_folder = get_path_to_folder($database, $default_folder_id);
$folder_name = pg_fetch_row(pg_query($database, "select caption from folder where identifier='$default_folder_id'"));
site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_name[2]\">My folders and albums</a>$path_to_folder : <a href=folder.php?folder=$default_folder_id>$folder_name[0]</a> : Import photos", "");

print "&nbsp;<br/>";
print "<table align=\"left\" border=\"0\" width=\"100%\"><tr><td align=\"left\" >" ;

switch ($original_file_type) {
 default:
   $image_data = load_default_image_data_values($default_folder_id);
   $image_data['file'][0]['name']     = $file_name;
   $image_data['file'][0]['name_tmp'] = $file_name_tmp;
   $image_data['file'][0]['type']     = $original_file_type;
   $image_data['file'][0]['remark']   = "";
   $image_data['file'][0]['master']   = "t";
   $image_data['num_of_files'] = 1;
   photo_import($database, 0, $im_options, $im_composite_options, $dcraw_options, $po_user['id'], $default_folder_id, $image_data);
   print "</p><p>Import finished.</p>";
   print "</td></tr></table>" ;

   print "&nbsp;<br/>";

   site_footer($database);
   site_epilog($database);
   exit();
 case "local":
   if ($preferences[0] == 'f') {
     print "Bulk upload is disabled for this account.<br/>Contact you Photo Organizer administrator to enable this feature.<p>";
     break;
   }

   $temporary_directory = $local_path;
   print "Importing photos from <b>$temporary_directory</b> ... <br/> ";
   break;
 case "gz":
 case "tgz":
 case "bz2":
 case "bzip2":
 case "tar":
 case "zip":
   /* check if bulk upload is enabled for this user */
   if ($preferences[0] == 'f') {
     print "Bulk upload is disabled for this account.<br/>Contact you Photo Organizer administrator to enable this feature.<p>";
     break;
   }
   /* in case the file type is zip, uncompress it and process the bulk upload */
   $temporary_directory = tempnam($tmp_volume_path, "po.import.");
   unlink($temporary_directory);
   print "Creating temporary directory <b>$temporary_directory</b> ... ";
   $old_mask = umask(0000);
   if (!mkdir($temporary_directory)) {
     print "<font color=\"red\">failed</font> [mkdir $temporary_directory]<br/>";
   } else {
     print "done.<br/>";
   }

   print "Move uploaded file into temporary directory ... ";
   if (!move_uploaded_file($file_name_tmp, $temporary_directory . "/" . $file_name)) {
     print "<font color=\"red\">failed</font> [mv $file_name_tmp $temporary_directory/$file_name] <br/>";
   } else {
     print "done.<br/>";
   }

   print "Uncompressing $file_name ... ";

   switch ($original_file_type) {
   case "gz":
   case "tgz":
     system("$sys_tar -x -z -C " .
            escapeshellarg($temporary_directory) ." -f" .
            escapeshellarg($temporary_directory ."/" . $file_name), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [tar -x -z -C $temporary_directory -f $temporary_directory/$file_name]<br/>";
     }
     else {
       print "done.<br/>";
     }
     break;
   case "bzip2":
   case "bz2":
     system("$sys_tar -x -j -C ".
            escapeshellarg($temporary_directory) ." -f".
            escapeshellarg($temporary_directory ."/". $file_name), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [tar -x -j -C $temporary_directory -f $temporary_directory/$file_name]<br/>";
     }
     else {
       print "done.<br/>";
     }
     break;
   case "tar":
     system("$sys_tar -x -C ".
            escapeshellarg($temporary_directory) ." -f".
            escapeshellarg($temporary_directory ."/". $file_name), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [tar -x -C $temporary_directory -f $temporary_directory/$file_name]<br/>";
     }
     else {
       print "done.<br/>";
     }
     break;
   case "zip":
     system("$sys_unzip -q ".
            escapeshellarg($temporary_directory. "/". $file_name) ." -d".
            escapeshellarg($temporary_directory), $retval);
     if ($retval) {
       print "<font color=\"red\">failed</font> [unzip $temporary_directory/$file_name -d temporary_directory]<br/>";
     }
     else {
       print "done.<br/>";
     }
     break;
   }
}

umask(0077);

upload_directory($database, $temporary_directory, $po_user['id'], $default_folder_id, $im_options, $im_composite_options, $dcraw_options);

umask($old_mask);

print "&nbsp;<br/>";
print "Upload finished.<br/>";
print "&nbsp;<br/>";
print "</td></tr></table>" ;

print "&nbsp;<br/>";

site_footer($database);
site_epilog($database);

?>
