<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2006 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/vars.php";
include_once "include/config.php";
include_once "$theme/theme.php";
include_once "include/import.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/mime.php";

$database = site_prolog();

if ($po_user['type'] < $user_type['user']) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$photo_id           = pg_escape_string($_REQUEST['photo']);
$version_id         = pg_escape_string($_REQUEST['version']);
$master             = pg_escape_string($_REQUEST['master']);
$comment            = pg_escape_string($_REQUEST['comment']);
$colorspace         = pg_escape_string($_REQUEST['colorspace']);

$file_name          = $_FILES['file_name']['name'][0];
$file_size          = $_FILES['file_name']['size'][0];
$file_name_tmp      = $_FILES['file_name']['tmp_name'][0];

$photo_data = pg_fetch_row(pg_query($database, "
  select caption, users
    from photo
   where photo.identifier = '$photo_id'"));

/* Enforce ownership */
if (($po_user['type'] != $user_type['administrator']) &&
    ($po_user['id'] != $photo_data[1])) {
  site_epilog($database);
  header("location: login.php");
  exit();
}

$im_options = get_im_options($database, $po_user['id']);

$preferences = pg_fetch_row(pg_query($database, "
  select quota_size
    from users, preferences
   where preferences.identifier=users.preferences
     and users.identifier=$po_user[id]"));

if ($file_name_tmp) {
  $original_file_type = strtolower(substr($file_name, strrpos($file_name, ".") + 1));
  $file_type               = $mime_type[$original_file_type]['out'];
  $multi_page_parameter    = $mime_type[$original_file_type]['page'];
  $mime_type_name          = $mime_type[$original_file_type]['name'];
  $decoder                 = $mime_type[$original_file_type]['decoder'];
  
  if (!$file_type) {
    $file_type = "jpeg";
  }

  $result = pg_fetch_row(pg_query($database, "
   select small_image_path, medium_image_path, large_image_path
    from photo_version
   where photo=$photo_id
     and identifier=$version_id"));

  // remove old files from the repository - since the file extensions might be different,
  error_reporting(0);
  unlink($image_repository_path  . "/"  . $result[0]);
  unlink($image_repository_path  . "/"  . $result[1]);
  unlink($image_repository_path  . "/"  . $result[2]);
  error_reporting(1);

  // generate new file names, with the apropriate file type
  $thumb_name = strtolower(substr($result[0], 0, strrpos($result[0], "."))) . "." . $file_type;
  $image_name = strtolower(substr($result[1], 0, strrpos($result[1], "."))) . "." . $file_type;
  $hires_name = strtolower(substr($result[2], 0, strrpos($result[2], "."))) . "." . $file_type;

  site_header($page_width, "Edit Photo Version");
  $folder_data = pg_fetch_row(pg_query($database, "select folder.identifier, folder.caption from photo, folder where photo.folder = folder.identifier and photo.identifier='$photo_id'"));
  site_navigator_status("<a href=\"user.php\">Users</a> : <a href=\"user.php?user=$user_name[0]\">My Folders and Albums</a> : <a href=\"folder.php?folder=$folder_data[0]\">$folder_data[1]</a> : <a href=\"photo.php?photo=$photo_id&detail_info=5\">$photo_data[0]</a> : Replacing photo version and saving changes", "");
  print "&nbsp;<br/>\n";
  print "<table width=\"100%\"><tr><td>" ;
  print "Uploading the $mime_type_name file <b>$file_name</b> as a new version of <a href=\"photo.php?photo=$photo_id&detail_info=5\"><b>$photo_data[0]</b></a><br/>";
  flush();
  print "<ul>";

  if ($preferences[0] > 0) {
    $used_storage_space = count_storage_space_by_user($database, $po_user['id']);
    $used_storage_space += filesize($file_name_tmp);
    if ($preferences[0] <= $used_storage_space) {
      print "Your account have reached the storage space quota of $preferences[0] Mb, imposed by your PO adminstrator.<br/>";
      print "No further uploads are possible.";
      print "</ul></p></td></tr></table><p>";
      site_footer($database);
      site_epilog($database);
      exit();
    }
  }

  $image_data['file'][0]['name']     = $file_name;
  $image_data['file'][0]['name_tmp'] = $file_name_tmp;
  $image_data['file'][0]['type']     = $original_file_type;
  $image_data['file'][0]['remark']   = "";
  $image_data['file'][0]['master']   = "f";

  $my_im_composite_options = get_im_composite_options($database, $po_user['id']);
  $dcraw_options = get_dcraw_options($database, $po_user['id']);

  if (file_upload($image_data, 0,      $im_options, $my_im_composite_options, $dcraw_options, $hires_name, $image_name, $thumb_name, $multi_page_parameter, $decoder, $database)) {
    $result = pg_fetch_row(pg_query($database, "
      update photo_version
         set small_image_path = '$thumb_name',
             medium_image_path = '$image_name',
             large_image_path = '$hires_name',
             original_image_name = '$file_name',
             colorspace = '$colorspace'
       where photo=$photo_id
         and identifier=$version_id"));
  }

  print "</ul>";
  print "&nbsp;<br/>\n";
  print "Upload finished, changes saved.";
  print "&nbsp;<br/>\n";
  print "</td></tr></table>" ;

  print "&nbsp;<br/>\n";
}

if ($master=='t') {
  $result = pg_query($database, "update photo_version set master='f' where photo=$photo_id");
}
$result = pg_query($database, "update photo_version set master='$master', comment = '$comment' where identifier=$version_id");
site_epilog($database);
if (!$file_name_tmp) {
  header("location: photo.php?photo=$photo_id&detail_info=5");
}
?>
